using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod : MonoBehaviour
    {
	public static string Modtag = " [CCAC]";
	public static string BSU = "<color=orange>[Big<color=white> & <color=blue>Small<color=white> Update]";
	public static string LAWU = "<color=blue>[Land, Air<color=white> & <color=blue>Water<color=white> Update]";
	public static string CateVersion = "[v1.1] ";

	public static string CreatorMade = "<color=yellow>[By Creator]<color=white>";
	public static void Main()
	{
    		//Quad
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Quad" + Modtag,
                    		NameToOrderByOverride = "CACC Quad",
                    		DescriptionOverride = "<color=yellow>[By: Creator]<color=white>" + "\nSlow quad.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Quad/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -2000f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -2000f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero);
                           		body.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 6);

                        		Instance.transform.GetChild(3).gameObject.SetActive(false);
                        		Instance.transform.GetChild(4).gameObject.SetActive(false);
                        		Instance.transform.GetChild(5).gameObject.SetActive(false);
                        		Instance.transform.GetChild(6).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Quad/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Quad/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-0.924499989f,-0.51700002f);
                        		wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.41f;
                        		wheels[1].anchor = new Vector2(1.00750005f,-0.51700002f);
                        		wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.41f;

                        		var engine = Instance.transform.GetChild(7);
                        		GameObject.Destroy(engine.gameObject.GetComponent<BoxCollider2D>());
					engine.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Quad/Engine.png", 1f);
					var collEngine1 = Instance.transform.GetChild(7).gameObject.AddComponent<BoxCollider2D>();
					collEngine1.offset = new Vector2(0.0152409896f,0.00653187186f);
					collEngine1.size = new Vector2(0.371601343f,0.177091554f);
					if(firstSpawn)
					{
                            			engine.transform.localPosition = new Vector2(0.254f,-0.279f);
					}

                        		var gastank = Instance.transform.GetChild(8);
                        		GameObject.Destroy(gastank.gameObject.GetComponent<BoxCollider2D>());
					gastank.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Quad/Gas Tank.png", 1f);
					var collGas1 = Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
					collGas1.offset = new Vector2(-0.167255253f,0.000944688916f);
					collGas1.size = new Vector2(0.326780677f,0.337282151f);
					var collGas2 = Instance.transform.GetChild(8).gameObject.AddComponent<BoxCollider2D>();
					collGas2.offset = new Vector2(0.108100623f,-0.111931339f);
					collGas2.size = new Vector2(0.456201196f,0.111469418f);	
					if(firstSpawn)
					{
                            			gastank.transform.localPosition = new Vector3(0.057f,-0.35f);
					}

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Quad/Body [0].png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Quad/Background.png");
                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/Quad/Body [1].png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/Quad/Background.png");
                        		var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite2.Body = ModAPI.LoadSprite("Vehicles/Quad/Body [2].png");
                        		CarSprite2.Background = ModAPI.LoadSprite("Vehicles/Quad/Background.png");
                        		var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite3.Body = ModAPI.LoadSprite("Vehicles/Quad/Body [3].png");
                        		CarSprite3.Background = ModAPI.LoadSprite("Vehicles/Quad/Background.png");
                        		var CarSprite4 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite4.Body = ModAPI.LoadSprite("Vehicles/Quad/Body [4].png");
                        		CarSprite4.Background = ModAPI.LoadSprite("Vehicles/Quad/Background.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
						,CarSprite1
						,CarSprite2
						,CarSprite3
						,CarSprite4
                        		};

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
                        		body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.49629578f,0.579055071f),
						new Vector2(0.222647294f,0.571858346f),
						new Vector2(0.221265897f,0.490739107f),
						new Vector2(0.437766105f,0.486291617f),
						new Vector2(0.598785162f,0.320649683f),
						new Vector2(0.51897949f,0.315994859f),
						new Vector2(0.423942178f,0.414055288f),
						new Vector2(0.228162453f,0.429945767f),
						new Vector2(-0.0702842101f,0.235811949f),
						new Vector2(-0.575905979f,0.226229653f),
						new Vector2(-0.645592988f,0.292548776f),
						new Vector2(-0.860236943f,0.29543522f),
						new Vector2(-0.862023115f,0.353337437f),
						new Vector2(-1.48407698f,0.35490042f),
						new Vector2(-1.4855088f,0.292064846f),
						new Vector2(-1.39993083f,0.293883801f),
						new Vector2(-1.40721333f,0.125100046f),
						new Vector2(-1.30653942f,0.0643839836f),
						new Vector2(-1.08571136f,0.0695958436f),
						new Vector2(-1.04927647f,0.13388592f),
						new Vector2(-0.800088584f,0.0510972291f),
						new Vector2(-0.821726263f,0.0171392001f),
						new Vector2(-0.570342124f,-0.139315367f),
						new Vector2(-0.386649609f,-0.305656701f),
						new Vector2(-0.270321131f,-0.541853011f),
						new Vector2(0.396927893f,-0.542733014f),
						new Vector2(0.779513538f,0.170485511f),
						new Vector2(1.16520071f,0.1369939f),
						new Vector2(1.29879785f,0.0427763611f),
						new Vector2(1.40481067f,0.0542632602f),
						new Vector2(1.4361279f,0.28737995f),
						new Vector2(1.39398384f,0.38260439f),
						new Vector2(0.876012743f,0.382309169f),
						new Vector2(0.862690866f,0.297961235f),
						new Vector2(0.730127275f,0.344301313f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
					{
						new Vector2(-0.253052711f,-0.248183355f),
						new Vector2(-0.184760481f,-0.184869364f),
						new Vector2(-0.0632936433f,-0.183118373f),
						new Vector2(-0.0299709514f,-0.21151185f),
						new Vector2(0.193604827f,-0.212547094f),
						new Vector2(0.249738738f,-0.184883893f),
						new Vector2(0.391254544f,-0.266251564f),
						new Vector2(0.391220331f,-0.519348383f),
						new Vector2(-0.236013606f,-0.519819379f)
					});

                        		foreach (Collider2D collider in Instance.transform.GetChild(0).gameObject.GetComponentsInChildren<Collider2D>())
                                	{   
                                    		NoCollideWithBodyPart noCollide = Instance.transform.GetChild(0).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    		noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    		noCollide.Collider = collider;
                                	}
                        		foreach (Collider2D collider in Instance.transform.GetChild(7).gameObject.GetComponentsInChildren<Collider2D>())
                                	{   
                                    		NoCollideWithBodyPart noCollide = Instance.transform.GetChild(7).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    		noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    		noCollide.Collider = collider;
                                	}
                        		foreach (Collider2D collider in Instance.transform.GetChild(8).gameObject.GetComponentsInChildren<Collider2D>())
                                	{   
                                    		NoCollideWithBodyPart noCollide = Instance.transform.GetChild(8).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    		noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    		noCollide.Collider = collider;
                                	}
                        	}
			}
		);
    		//Traffic Cone
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Bowling Pin"),
                    		NameOverride = "Traffic Cone" + Modtag,
                    		NameToOrderByOverride = "CACC Traffic Cone",
                    		DescriptionOverride = "<color=yellow>[By: Creator]<color=white>" + "\nTraffic cone that can be used to block road, not really",
                    		CategoryOverride = ModAPI.FindCategory("Misc."),
                    		ThumbnailOverride = ModAPI.LoadSprite("Props/Cone Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
					Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Props/Cone.png");
					Instance.FixColliders();
                        	}
			}
		);
    		//Turret Gun
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Soviet Submachine Gun"),
                    		NameOverride = "Turret Gun" + Modtag,
                    		NameToOrderByOverride = "CACC Turret Gun",
                    		DescriptionOverride = "<color=yellow>[By: Creator]<color=white>" + "\nMachine Gun",
                    		CategoryOverride = ModAPI.FindCategory("Firearms"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Small Military Truck/Gun Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
					Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Gun.png");
					Instance.FixColliders();
                        	}
			}
		);
    		//Lada Niva
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Lada Niva" + Modtag,
                    		NameToOrderByOverride = "CACC Lada Niva",
                    		DescriptionOverride = "<color=yellow>[By: Creator]<color=white>" + "\nRussian car that can be packed with bunch of things.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Lada NIVA/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -3675f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -3675f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(6).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-1.58200002f,-1.10599995f);
                        		wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.52f;
                        		wheels[1].anchor = new Vector2(1.83399999f,-1.10599995f);
                        		wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.52f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Lada NIVA/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Lada NIVA/Background.png");
                        		CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/Lada NIVA/Front Doors.png");
                        		CarSprite.Bonnet = ModAPI.LoadSprite("Vehicles/Lada NIVA/Hood.png");
                        		CarSprite.Boot = ModAPI.LoadSprite("Vehicles/Lada NIVA/Bonnet.png");

                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/Lada NIVA/Red/Body.png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/Lada NIVA/Background.png");
                        		CarSprite1.FrontDoor = ModAPI.LoadSprite("Vehicles/Lada NIVA/Red/Front Doors.png");
                        		CarSprite1.Bonnet = ModAPI.LoadSprite("Vehicles/Lada NIVA/Red/Hood.png");
                        		CarSprite1.Boot = ModAPI.LoadSprite("Vehicles/Lada NIVA/Red/Bonnet.png");

                        		var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite2.Body = ModAPI.LoadSprite("Vehicles/Lada NIVA/Blue/Body.png");
                        		CarSprite2.Background = ModAPI.LoadSprite("Vehicles/Lada NIVA/Background.png");
                        		CarSprite2.FrontDoor = ModAPI.LoadSprite("Vehicles/Lada NIVA/Blue/Front Doors.png");
                        		CarSprite2.Bonnet = ModAPI.LoadSprite("Vehicles/Lada NIVA/Blue/Hood.png");
                        		CarSprite2.Boot = ModAPI.LoadSprite("Vehicles/Lada NIVA/Blue/Bonnet.png");

                        		var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite3.Body = ModAPI.LoadSprite("Vehicles/Lada NIVA/Black/Body.png");
                        		CarSprite3.Background = ModAPI.LoadSprite("Vehicles/Lada NIVA/Background.png");
                        		CarSprite3.FrontDoor = ModAPI.LoadSprite("Vehicles/Lada NIVA/Black/Front Doors.png");
                        		CarSprite3.Bonnet = ModAPI.LoadSprite("Vehicles/Lada NIVA/Black/Hood.png");
                        		CarSprite3.Boot = ModAPI.LoadSprite("Vehicles/Lada NIVA/Black/Bonnet.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
						,CarSprite1
						,CarSprite2
						,CarSprite3
                        		};

                        		var engine = Instance.transform.GetChild(7);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector2(1.829f,-0.372999996f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector2(-1.58200002f,-0.499000013f);
					}

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(-0.203999996f,-0.181999996f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl1 = part2.AddComponent<BoxCollider2D>();
					boxColl1.offset = new Vector2(-0.279263079f,0.00575792789f);
					boxColl1.size = new Vector2(0.19362998f,1.35521626f);
                            		var boxColl2 = part2.AddComponent<BoxCollider2D>();
					boxColl2.offset = new Vector2(0.0918133259f,-0.533767998f);
					boxColl2.size = new Vector2(0.578393221f,0.273626357f);

				// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector2(0.112000003f,-0.0280000009f);
					}
					frontdoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.758430243f,0.811062694f),
						new Vector2(-0.753935933f,-0.726198316f),
						new Vector2(-0.662572622f,-0.805641413f),
						new Vector2(0.722166419f,-0.811554074f),
						new Vector2(0.776418507f,-0.69794631f),
						new Vector2(0.782736123f,0.0965542495f),
						new Vector2(0.667571068f,0.279429793f),
						new Vector2(0.146843195f,0.805521488f)
					});

				// [B O O T] Collider
                        		var boot = Instance.transform.GetChild(4);
					if(firstSpawn)
					{
						boot.localPosition = new Vector2(-2.32399988f,0.112000003f);
					}
                        		boot.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.35112375f,0.697646141f);
					boot.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.0609658509f,0.416549206f),
						new Vector2(-0.0727346018f,0.205844373f),
						new Vector2(-0.308288932f,-0.208288833f),
						new Vector2(-0.312120557f,-0.704221129f),
						new Vector2(-0.257056057f,-0.662879348f),
						new Vector2(-0.255988121f,-0.217872545f),
						new Vector2(0.0711839199f,0.333926022f),
						new Vector2(0.367559075f,0.700244427f),
						new Vector2(0.317477107f,0.699759007f)
					});

				// [B O N N E T] Collider
                        		var bonnet = Instance.transform.GetChild(3);
					if(firstSpawn)
					{
						bonnet.localPosition = new Vector2(1.83399999f,-0.0140000004f);
					}
					bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.710001588f,0.161623284f),
						new Vector2(-0.749127626f,0.0439331271f),
						new Vector2(-0.572483301f,-0.154242381f),
						new Vector2(0.739265561f,-0.152830541f),
						new Vector2(0.717752576f,-0.0547945723f),
						new Vector2(0.554785013f,0.0182186216f)
					});
                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}

				// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 1;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(2.82703924f,-0.757646978f),
						new Vector2(2.82093549f,-0.611665964f),
						new Vector2(2.57927179f,-0.614469111f),
						new Vector2(2.57292747f,-0.166046709f),
						new Vector2(1.24782145f,-0.163634166f),
						new Vector2(1.11315644f,-0.00333271176f),
						new Vector2(1.11564291f,0.161395505f),
						new Vector2(1.04767513f,0.16786167f),
						new Vector2(0.389282882f,0.845816374f),
						new Vector2(0.222353414f,0.897035122f),
						new Vector2(-1.8661375f,0.899358869f),
						new Vector2(-1.95419145f,0.849883974f),
						new Vector2(-2.03214145f,0.768152893f),
						new Vector2(-1.84665692f,0.792912662f),
						new Vector2(0.269451082f,0.789245248f),
						new Vector2(0.810172617f,0.233856201f),
						new Vector2(0.886044145f,0.0898309052f),
						new Vector2(0.660168707f,0.227934375f),
						new Vector2(0.354629785f,0.279628396f),
						new Vector2(0.335819513f,0.141592219f),
						new Vector2(0.245648742f,0.127083465f),
						new Vector2(0.197553739f,0.152003288f),
						new Vector2(0.247170508f,0.361015171f),
						new Vector2(0.196519285f,0.366715252f),
						new Vector2(0.0431086421f,-0.0859038085f),
						new Vector2(0.112903699f,-0.0825783536f),
						new Vector2(0.172705546f,0.0875949264f),
						new Vector2(0.244743258f,0.0699893385f),
						new Vector2(0.238965094f,-0.110558614f),
						new Vector2(0.642208695f,-0.173886284f),
						new Vector2(0.671015441f,-0.741419792f),
						new Vector2(0.89304781f,-0.757597923f),
						new Vector2(-2.34485531f,-0.759934247f),
						new Vector2(-2.37735748f,-0.646148503f),
						new Vector2(-2.63847303f,-0.633741379f),
						new Vector2(-2.83174896f,-0.650676012f),
						new Vector2(-2.82064176f,-0.804115951f),
						new Vector2(-2.44425178f,-0.825757444f),
						new Vector2(-2.35958719f,-0.867799103f),
						new Vector2(-1.80545306f,-0.883195758f),
						new Vector2(-1.01977754f,-0.889854908f),
						new Vector2(1.27217972f,-0.893644035f),
						new Vector2(2.41831279f,-0.865194678f),
						new Vector2(2.74715137f,-0.828469217f)
					});
                        	}
			}
		);
    		//Van
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Van" + Modtag,
                    		NameToOrderByOverride = "CACC Van",
                    		DescriptionOverride = "<color=yellow>[By: Creator]<color=white>" + "\nVan that can be used to kidnap someone.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Van/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -2750f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -2750f;

                           		body.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 6);

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(6).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Van/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Van/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-1.7385f,-1.23969996f);
                        		wheels[1].anchor = new Vector2(3.24900007f,-1.23969996f);

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Van/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Van/Background.png");
                        		CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/Van/Front Doors.png");
                        		CarSprite.Bonnet = ModAPI.LoadSprite("Vehicles/Van/Bonnet.png");
                        		CarSprite.Boot = ModAPI.LoadSprite("Vehicles/Van/Boot.png");

                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/Van/Free Candy/Body.png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/Van/Background.png");
                        		CarSprite1.FrontDoor = ModAPI.LoadSprite("Vehicles/Van/Front Doors.png");
                        		CarSprite1.Bonnet = ModAPI.LoadSprite("Vehicles/Van/Bonnet.png");
                        		CarSprite1.Boot = ModAPI.LoadSprite("Vehicles/Van/Boot.png");

                        		var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite2.Body = ModAPI.LoadSprite("Vehicles/Van/Black/Body.png");
                        		CarSprite2.Background = ModAPI.LoadSprite("Vehicles/Van/Background.png");
                        		CarSprite2.FrontDoor = ModAPI.LoadSprite("Vehicles/Van/Black/Front Doors.png");
                        		CarSprite2.Bonnet = ModAPI.LoadSprite("Vehicles/Van/Black/Bonnet.png");
                        		CarSprite2.Boot = ModAPI.LoadSprite("Vehicles/Van/Black/Boot.png");

                        		var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite3.Body = ModAPI.LoadSprite("Vehicles/Van/PPG Packages/Body.png");
                        		CarSprite3.Background = ModAPI.LoadSprite("Vehicles/Van/Background.png");
                        		CarSprite3.FrontDoor = ModAPI.LoadSprite("Vehicles/Van/Front Doors.png");
                        		CarSprite3.Bonnet = ModAPI.LoadSprite("Vehicles/Van/Bonnet.png");
                        		CarSprite3.Boot = ModAPI.LoadSprite("Vehicles/Van/Boot.png");

                        		var CarSprite4 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite4.Body = ModAPI.LoadSprite("Vehicles/Van/Labs INC/Body [1].png");
                        		CarSprite4.Background = ModAPI.LoadSprite("Vehicles/Van/Background.png");
                        		CarSprite4.FrontDoor = ModAPI.LoadSprite("Vehicles/Van/Front Doors.png");
                        		CarSprite4.Bonnet = ModAPI.LoadSprite("Vehicles/Van/Bonnet.png");
                        		CarSprite4.Boot = ModAPI.LoadSprite("Vehicles/Van/Boot.png");

                        		var CarSprite5 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite5.Body = ModAPI.LoadSprite("Vehicles/Van/Labs INC/Body [2].png");
                        		CarSprite5.Background = ModAPI.LoadSprite("Vehicles/Van/Background.png");
                        		CarSprite5.FrontDoor = ModAPI.LoadSprite("Vehicles/Van/Front Doors.png");
                        		CarSprite5.Bonnet = ModAPI.LoadSprite("Vehicles/Van/Bonnet.png");
                        		CarSprite5.Boot = ModAPI.LoadSprite("Vehicles/Van/Boot.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
						,CarSprite1
						,CarSprite2
						,CarSprite3
						,CarSprite4
						,CarSprite5
                        		};

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(1.68900001f,-0.123999998f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl1 = part2.AddComponent<BoxCollider2D>();
					boxColl1.offset = new Vector2(-0.279263079f,0.00575792789f);
					boxColl1.size = new Vector2(0.19362998f,1.35521626f);
                            		var boxColl2 = part2.AddComponent<BoxCollider2D>();
					boxColl2.offset = new Vector2(0.0918133259f,-0.533767998f);
					boxColl2.size = new Vector2(0.578393221f,0.273626357f);

                        		var engine = Instance.transform.GetChild(7);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(3.31500006f,-0.486000001f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector2(-1.73000002f,-0.680000007f);
					}


					// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector2(2.01300001f,0f);
					}
					frontdoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.271356583f,1.02050686f),
						new Vector2(-0.72891295f,1.01263726f),
						new Vector2(-0.744336605f,-1.0207324f),
						new Vector2(0.457349181f,-1.01786315f),
						new Vector2(0.739142299f,-0.414566278f),
						new Vector2(0.741448045f,0.236693487f),
						new Vector2(0.0152901635f,0.96700418f)
					});

					// [B O O T] Collider
                        		var boot = Instance.transform.GetChild(4);
					if(firstSpawn)
					{
						boot.localPosition = new Vector2(-3.78999996f,0.181999996f);
					}
                        		boot.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.210123271f,0.886934876f);
					boot.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.153125033f,0.895734906f),
						new Vector2(-0.0204661638f,0.555209577f),
						new Vector2(-0.162531927f,0.0365830064f),
						new Vector2(-0.16721727f,-0.897313118f),
						new Vector2(-0.114504337f,-0.894797266f),
						new Vector2(-0.104945585f,0.0264862776f),
						new Vector2(0.0412783623f,0.563665628f),
						new Vector2(0.22767885f,0.892611086f)
					});

					// [B O N N E T] Collider
                        		var bonnet = Instance.transform.GetChild(3);
					if(firstSpawn)
					{
						bonnet.localPosition = new Vector2(3.3829999f,0.0560000017f);
					}
					bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.63214767f,0.209224463f),
						new Vector2(-0.631527543f,-0.20972088f),
						new Vector2(0.630405903f,-0.209853023f),
						new Vector2(0.630088449f,-0.158140421f),
						new Vector2(0.457596868f,-0.0184939504f),
						new Vector2(0.0668608546f,0.0991900638f)
					});
                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 1;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(4.03132153f,-0.965919018f),
						new Vector2(4.03206635f,-0.630845547f),
						new Vector2(3.9452219f,-0.622738719f),
						new Vector2(3.95214462f,-0.153299212f),
						new Vector2(2.78496504f,-0.137178302f),
						new Vector2(2.71835375f,0.173508838f),
						new Vector2(2.81534028f,0.264254808f),
						new Vector2(2.09620357f,0.988278389f),
						new Vector2(1.72710919f,1.08125734f),
						new Vector2(-3.55464745f,1.08191407f),
						new Vector2(-3.68388391f,0.867779374f),
						new Vector2(-3.52355671f,0.941054702f),
						new Vector2(-3.26463342f,0.969180167f),
						new Vector2(1.71974146f,0.9573071f),
						new Vector2(1.9878931f,0.933178723f),
						new Vector2(2.6837759f,0.226714879f),
						new Vector2(2.4768374f,0.200094521f),
						new Vector2(2.18467283f,0.242926702f),
						new Vector2(2.14731598f,0.109229483f),
						new Vector2(2.01970625f,0.102470964f),
						new Vector2(2.0792644f,0.319059432f),
						new Vector2(2.0205977f,0.326091111f),
						new Vector2(1.86809003f,-0.127309889f),
						new Vector2(1.9336561f,-0.124394871f),
						new Vector2(1.999089f,0.0190649629f),
						new Vector2(2.06809115f,-0.155008748f),
						new Vector2(2.34645414f,-0.163152888f),
						new Vector2(2.46033835f,-0.222420722f),
						new Vector2(2.66327047f,-0.516421676f),
						new Vector2(2.46075392f,-0.238526106f),
						new Vector2(2.54581022f,-0.80238384f),
						new Vector2(-3.75404501f,-0.808629811f),
						new Vector2(-3.89190793f,-0.717785835f),
						new Vector2(-4.03071499f,-0.720283151f),
						new Vector2(-3.917171f,-1.07879663f),
						new Vector2(2.54321218f,-1.07025552f),
						new Vector2(3.95055628f,-1.02141452f)
					});
                        	}
			}
		);
    		//SMT
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Small Military Truck" + Modtag,
                    		NameToOrderByOverride = "CACC SMT",
                    		DescriptionOverride = "<color=yellow>[By: Creator]<color=white>" + "\nSmall military truck, you can use it's machine gun on top.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Small Military Truck/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -2750f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -2750f;

                           		body.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 3);

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(6).gameObject.SetActive(false);
                        		Instance.transform.GetChild(4).gameObject.SetActive(false);

					var RoofSprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Roof.png");
			
					if(body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 0)
					{
						RoofSprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Roof.png");
						Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Wheel.png", 1f);
            					Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Wheel.png", 1f);   
					} 
					if(body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 1)
					{
						RoofSprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Grey/Roof.png");
						Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Grey/Wheel.png", 1f);
            					Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Grey/Wheel.png", 1f);   
					}         
					if(body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 2)
					{
						RoofSprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Green/Roof.png");
						Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Green/Wheel.png", 1f);
            					Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Green/Wheel.png", 1f);   
					}        

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-1.85650003f,-1.28429997f);
                        		wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.6f;
                        		wheels[1].anchor = new Vector2(2.2276001f,-1.28429997f);
                        		wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.6f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Small Military Truck/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Small Military Truck/Background.png");
                        		CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/Small Military Truck/Front Doors.png");
                        		CarSprite.Bonnet = ModAPI.LoadSprite("Vehicles/Small Military Truck/Bonnet.png");

                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/Small Military Truck/Grey/Body.png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/Small Military Truck/Background.png");
                        		CarSprite1.FrontDoor = ModAPI.LoadSprite("Vehicles/Small Military Truck/Grey/Front Doors.png");
                        		CarSprite1.Bonnet = ModAPI.LoadSprite("Vehicles/Small Military Truck/Grey/Bonnet.png");

                        		var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite2.Body = ModAPI.LoadSprite("Vehicles/Small Military Truck/Green/Body.png");
                        		CarSprite2.Background = ModAPI.LoadSprite("Vehicles/Small Military Truck/Background.png");
                        		CarSprite2.FrontDoor = ModAPI.LoadSprite("Vehicles/Small Military Truck/Green/Front Doors.png");
                        		CarSprite2.Bonnet = ModAPI.LoadSprite("Vehicles/Small Military Truck/Green/Bonnet.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
						,CarSprite1
						,CarSprite2
                        		};

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(0.453000009f,-0.324000001f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl1 = part2.AddComponent<BoxCollider2D>();
					boxColl1.offset = new Vector2(-0.279263079f,0.00575792789f);
					boxColl1.size = new Vector2(0.19362998f,1.35521626f);
                            		var boxColl2 = part2.AddComponent<BoxCollider2D>();
					boxColl2.offset = new Vector2(0.0918133259f,-0.533767998f);
					boxColl2.size = new Vector2(0.578393221f,0.273626357f);

                        		GameObject part3 = new GameObject("Roof");
                        		part3.transform.parent = body;
                        		part3.transform.localScale = Vector3.one;
                        			part3.transform.localPosition = new Vector3(0.412999988f,0.547999978f);
                        		SpriteRenderer part3Renderer = part3.AddComponent<SpriteRenderer>();
                        		part3Renderer.sprite = RoofSprite;
                        		part3Renderer.sortingLayerName = "Top";
                        		part3.layer = LayerMask.NameToLayer("Objects");
                        		part3.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint1 = part3.AddComponent<FixedJoint2D>();
                        		fixedJoint1.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint1.breakForce = 875f;
                        		part3.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part3.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		part3.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		part3.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
                            		{
                                		new Vector2(-0.788902164f,0.476605594f),      
                                		new Vector2(-0.718340993f,0.131900445f),   
                                		new Vector2(-0.777497411f,-0.466520011f),   
                                		new Vector2(-0.483474731f,-0.468313515f),   
                                		new Vector2(-0.384404242f,-0.392836183f),   
                                		new Vector2(-0.395390481f,0.316398203f),   
                                		new Vector2(0.386175513f,0.297623754f),   
                                		new Vector2(0.795451164f,0.253558338f),   
                                		new Vector2(0.811028361f,0.334996819f),   
                                		new Vector2(0.586605728f,0.422870576f)
                            		});

                        		var lmg = ModAPI.FindSpawnable("Soviet Submachine Gun");
                        		var lmgPrefab = lmg.Prefab;
                        		var GunObject = GameObject.Instantiate(lmgPrefab, Instance.transform.position, Instance.transform.rotation);
					GunObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Small Military Truck/Gun.png");
                        		foreach(Collider2D Collider in GunObject.GetComponents<Collider2D>())
                            		{
                                		GameObject.Destroy(Collider);
                            		}
                        		GunObject.transform.parent = body;
					var boxGunColl1 = GunObject.AddComponent<BoxCollider2D>();
					boxGunColl1.offset = new Vector2(-0.469941109f,0.0187581182f);
					boxGunColl1.size = new Vector2(0.600254595f,0.163312554f);
					var boxGunColl2 = GunObject.AddComponent<BoxCollider2D>();
					boxGunColl2.offset = new Vector2(0.28666091f,0.0408274531f);
					boxGunColl2.size = new Vector2(1.19332182f,0.056073308f);
					var boxGunColl3 = GunObject.AddComponent<BoxCollider2D>();
					boxGunColl3.offset = new Vector2(-0.826049328f,0.0487823784f);
					boxGunColl3.size = new Vector2(0.116998732f,0.207564771f);

                            		GunObject.transform.localPosition = new Vector3(0.0219999999f,1.22800004f);
                            		HingeJoint2D hingeJoint = GunObject.AddComponent<HingeJoint2D>();
                            		hingeJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            		hingeJoint.anchor = new Vector2(-0.449999988f,-0.057500001f);
                            		hingeJoint.breakForce = 750f;
                            		hingeJoint.breakTorque = 600f;
                            		hingeJoint.limits = new JointAngleLimits2D()
                            		{
                               			 min = -360,
                               			 max = 360
                            		};
                            		hingeJoint.useLimits = true;

                        		var engine = Instance.transform.GetChild(7);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(2.20700002f,-0.523999989f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(-0.575999975f,-0.718999982f);
					}


					// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector3(0.556999981f,-0.428000003f);
					}
                        		foreach(PolygonCollider2D Collider in Instance.transform.GetChild(5).gameObject.GetComponents<PolygonCollider2D>())
                            		{
                                		GameObject.Destroy(Collider);
                            		}
					var doorColl1 = Instance.transform.GetChild(5).gameObject.AddComponent<BoxCollider2D>();
					doorColl1.offset = new Vector2(-0.0438303947f,0.0019056797f);
					doorColl1.size = new Vector2(1.19558764f,1.14558744f);

					// [B O N N E T] Collider
                        		var bonnet = Instance.transform.GetChild(3);
					if(firstSpawn)
					{
						bonnet.localPosition = new Vector3(2.26999998f,-0.0299999993f);
					}
					bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.823886514f,0.0983693302f),
						new Vector2(-0.824042082f,0.0462325439f),
						new Vector2(-0.682309628f,-0.0990903527f),
						new Vector2(0.828451157f,-0.0982360616f),
						new Vector2(0.829087019f,0.0364288948f),
						new Vector2(0.763975382f,0.0994238108f)
					});

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 1;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(3.0969193f,-0.685939372f),
						new Vector2(3.10295296f,-0.122933634f),
						new Vector2(1.59247172f,-0.124857426f),
						new Vector2(1.39386261f,0.114431269f),
						new Vector2(1.14477396f,0.163691372f),
						new Vector2(1.14792228f,0.869429946f),
						new Vector2(1.07315814f,0.833191454f),
						new Vector2(1.07319522f,0.144398168f),
						new Vector2(1.13511479f,0.108892463f),
						new Vector2(1.13097417f,-0.134256661f),
						new Vector2(1.13236225f,-0.416484892f),
						new Vector2(1.12594104f,-1.01144052f),
						new Vector2(-0.0478183031f,-1.01211774f),
						new Vector2(-0.0482493937f,-0.946195602f),
						new Vector2(-0.0408311039f,0.240657777f),
						new Vector2(-0.227075785f,0.236739993f),
						new Vector2(-0.336313933f,0.146040171f),
						new Vector2(-0.331907481f,0.0160994604f),
						new Vector2(-0.388832718f,0.00326988101f),
						new Vector2(-0.405301452f,0.474449962f),
						new Vector2(-0.361953437f,1.12602723f),
						new Vector2(-0.386873603f,1.24084568f),
						new Vector2(-0.457023501f,1.24084568f),
						new Vector2(-0.505832613f,1.13857627f),
						new Vector2(-0.484356701f,0.502077878f),
						new Vector2(-0.5006513f,0.00929119065f),
						new Vector2(-3.19042492f,0.00632981211f),
						new Vector2(-3.12521195f,-0.0762251318f),
						new Vector2(-3.12036896f,-0.866375387f),
						new Vector2(-2.62139869f,-1.03862786f),
						new Vector2(-0.391238809f,-1.0425837f),
						new Vector2(-0.269274652f,-1.12652731f),
						new Vector2(-0.200464308f,-1.24220812f),
						new Vector2(1.26974511f,-1.24408031f),
						new Vector2(1.29543638f,-1.08665001f),
						new Vector2(1.51526499f,-1.06143439f),
						new Vector2(3.14912319f,-1.03768826f),
						new Vector2(3.16699362f,-0.723293066f)
					});
                        	}
			}
		);
    		//Chevrolet Corvette ZL1
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Chevrolet Corvette ZL1" + Modtag,
                    		NameToOrderByOverride = "CACC Chevrolet Corvette ZL1",
                    		DescriptionOverride = "<color=orange>[Idea by: Klej]<color=white>" + "\nSport car.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -4450f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -4450f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(6).gameObject.SetActive(false);
                        		Instance.transform.GetChild(4).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-2.30999994f,-0.570900023f);
                        		wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.57f;
                        		wheels[1].anchor = new Vector2(2.19930005f,-0.570900023f);
                        		wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.57f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Background.png");
                        		CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Front Doors.png");
                        		CarSprite.Bonnet = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Bonnet.png");

                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Orange/Body.png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Background.png");
                        		CarSprite1.FrontDoor = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Orange/Front Doors.png");
                        		CarSprite1.Bonnet = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Orange/Bonnet.png");

                        		var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite2.Body = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Blue/Body.png");
                        		CarSprite2.Background = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Background.png");
                        		CarSprite2.FrontDoor = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Blue/Front Doors.png");
                        		CarSprite2.Bonnet = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Blue/Bonnet.png");

                        		var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite3.Body = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Black/Body.png");
                        		CarSprite3.Background = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Background.png");
                        		CarSprite3.FrontDoor = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Black/Front Doors.png");
                        		CarSprite3.Bonnet = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Black/Bonnet.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
						,CarSprite1
						,CarSprite2
						,CarSprite3
                        		};

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(-0.778999984f,0.00200000009f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
					part2.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.362319529f,0.61819011f),
						new Vector2(-0.436649382f,0.617118895f),
						new Vector2(-0.505624712f,0.565665781f),
						new Vector2(-0.503759861f,0.329081357f),
						new Vector2(-0.434651792f,-0.00027410686f),
						new Vector2(-0.235138997f,-0.526065648f),
						new Vector2(-0.145197242f,-0.5342834f),
						new Vector2(-0.148766071f,-0.612868726f),
						new Vector2(0.383648574f,-0.612868726f),
						new Vector2(0.407876402f,-0.526735842f),
						new Vector2(0.501180708f,-0.477414608f),
						new Vector2(0.490909338f,-0.337690771f),
						new Vector2(0.437561452f,-0.235854194f),
						new Vector2(0.0373045057f,-0.381144792f),
						new Vector2(-0.155179441f,-0.0750672519f),
						new Vector2(-0.277865946f,0.237931818f),
						new Vector2(-0.302002251f,0.560797632f)		
					});

                        		var engine = Instance.transform.GetChild(7);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(2.14100003f,-0.194999993f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(-2.29999995f,-0.075000003f);
					}


					// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector3(-0.344000012f,0.0439999998f);
					}
					frontdoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.769770801f,0.409885406f),
						new Vector2(0.112855963f,0.728445053f),
						new Vector2(-0.901469588f,0.740027964f),
						new Vector2(-0.942291617f,0.434755147f),
						new Vector2(-1.13232791f,0.289717942f),
						new Vector2(-1.14370239f,-0.0818748921f),
						new Vector2(-0.996412516f,-0.405662566f),
						new Vector2(-0.789504647f,-0.61010468f),
						new Vector2(-0.320474595f,-0.667904139f),
						new Vector2(1.1487844f,-0.72028327f),
						new Vector2(1.14999998f,0.0749999955f),
						new Vector2(1.00261855f,0.239279851f)
					});

					// [B O N N E T] Collider
                        		var bonnet = Instance.transform.GetChild(3);
					if(firstSpawn)
					{
						bonnet.localPosition = new Vector3(2.19849992f,0.140599996f);
					}
					bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.54923439f,0.195091248f),
						new Vector2(-0.837002754f,0.200699717f),
						new Vector2(-0.832484722f,0.143965393f),
						new Vector2(-0.536877394f,0.136177555f),
						new Vector2(0.107784033f,0.0754636824f),
						new Vector2(0.395412385f,0.00987207144f),
						new Vector2(0.827321053f,-0.198279381f),
						new Vector2(0.800697327f,-0.116814613f),
						new Vector2(0.256177545f,0.113566585f)
					});

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.311255515f,0.594086051f),
						new Vector2(-0.149198502f,0.819084108f),
						new Vector2(-0.298196077f,0.857854605f),
						new Vector2(-1.18790758f,0.855275393f),
						new Vector2(-1.93687916f,0.730831027f),
						new Vector2(-2.39462423f,0.634994149f),
						new Vector2(-2.96398783f,0.494634509f),
						new Vector2(-3.12022614f,0.71096921f),
						new Vector2(-3.35153341f,0.71722883f),
						new Vector2(-3.34435034f,0.4738307f),
						new Vector2(-3.40636039f,0.0688045621f),
						new Vector2(-3.36365771f,-0.248334751f),
						new Vector2(-3.16457272f,-0.673515618f),
						new Vector2(-2.98507023f,-0.719265461f),
						new Vector2(-1.63487256f,-0.787279606f),
						new Vector2(-1.18462157f,-0.737734854f),
						new Vector2(-0.711202204f,-0.719672441f),
						new Vector2(-0.238002658f,-0.762438715f),
						new Vector2(0.843646586f,-0.792846143f),
						new Vector2(1.5310216f,-0.788699746f),
						new Vector2(2.8337357f,-0.843799233f),
						new Vector2(3.28843498f,-0.817587018f),
						new Vector2(3.43568444f,-0.730245113f),
						new Vector2(3.3965714f,-0.604213715f),
						new Vector2(3.2457726f,-0.523370981f),
						new Vector2(3.3022697f,-0.258270442f),
						new Vector2(3.09324455f,-0.0365408212f),
						new Vector2(2.66252279f,0.194310114f),
						new Vector2(2.30729723f,0.270577878f),
						new Vector2(1.6486485f,0.338465542f),
						new Vector2(0.914253235f,0.392042965f),
						new Vector2(0.947780371f,0.316809982f),
						new Vector2(0.765231013f,0.318519533f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
					{
						new Vector2(-1.15475452f,-0.586562514f),
						new Vector2(-1.42638397f,-0.280230105f),
						new Vector2(-1.49321163f,-0.0781462044f),
						new Vector2(-1.4931798f,0.157323986f),
						new Vector2(-1.441872f,0.345591962f),
						new Vector2(-1.27671456f,0.660748243f),
						new Vector2(-1.26936889f,0.773585975f),
						new Vector2(-1.26862073f,0.802346647f),
						new Vector2(-1.26325536f,0.805130363f),
						new Vector2(-0.245104641f,0.79623735f),
						new Vector2(-0.0361000896f,0.705967128f),
						new Vector2(0.29769066f,0.523903549f),
						new Vector2(0.638078213f,0.317446321f),
						new Vector2(0.793638468f,0.114790559f),
						new Vector2(0.795282423f,-0.266194969f),
						new Vector2(0.790962458f,-0.709671259f),
						new Vector2(0.512733042f,-0.710792482f),
						new Vector2(-0.25832209f,-0.681830645f)
					});
                        	}
			}
		);
    		//Range Rover 0.5i V8 Supercharged
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Range Rover 0.5i V8 Supercharged" + Modtag,
                    		NameToOrderByOverride = "CACC Range Rover 0.5i V8 Supercharged",
                    		DescriptionOverride = "<color=yellow>[By: Creator]<color=white>" + "\nLets say it's sport jeep.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Range Rover 0.5i V8 Supercharged/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -4000f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -4000f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(4).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Range Rover 0.5i V8 Supercharged/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Range Rover 0.5i V8 Supercharged/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-1.79999995f,-0.870000005f);
                        		wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.57f;
                        		wheels[1].anchor = new Vector2(2.22799993f,-0.870000005f);
                        		wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.57f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Range Rover 0.5i V8 Supercharged/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Range Rover 0.5i V8 Supercharged/Background.png");
                        		CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/Range Rover 0.5i V8 Supercharged/Front Doors.png");
                        		CarSprite.BackDoor = ModAPI.LoadSprite("Vehicles/Range Rover 0.5i V8 Supercharged/Back Doors.png");
                        		CarSprite.Bonnet = ModAPI.LoadSprite("Vehicles/Range Rover 0.5i V8 Supercharged/Bonnet.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
                        		};

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(0.319000006f,-0.175999999f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl1 = part2.AddComponent<BoxCollider2D>();
					boxColl1.offset = new Vector2(-0.279263079f,0.00575792789f);
					boxColl1.size = new Vector2(0.19362998f,1.35521626f);
                            		var boxColl2 = part2.AddComponent<BoxCollider2D>();
					boxColl2.offset = new Vector2(0.0918133259f,-0.533767998f);
					boxColl2.size = new Vector2(0.578393221f,0.273626357f);

                        		GameObject part3 = new GameObject("Chair 2");
                        		part3.transform.parent = body;
                        		part3.transform.localScale = Vector3.one;
                        		part3.transform.localPosition = new Vector3(-0.700999975f,-0.175999999f);
                        		SpriteRenderer part3Renderer = part3.AddComponent<SpriteRenderer>();
                        		part3Renderer.sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Chair.png");
                        		part3Renderer.sortingLayerName = "Foreground";
                        		part3.layer = LayerMask.NameToLayer("Objects");
                        		part3.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint1 = part3.AddComponent<FixedJoint2D>();
                        		fixedJoint1.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint1.breakForce = 875f;
                        		part3.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part3.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl3 = part3.AddComponent<BoxCollider2D>();
					boxColl3.offset = new Vector2(-0.279263079f,0.00575792789f);
					boxColl3.size = new Vector2(0.19362998f,1.35521626f);
                            		var boxColl4 = part3.AddComponent<BoxCollider2D>();
					boxColl4.offset = new Vector2(0.0918133259f,-0.533767998f);
					boxColl4.size = new Vector2(0.578393221f,0.273626357f);

                        		var engine = Instance.transform.GetChild(7);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(2.2249999f,-0.398999989f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(-1.83099997f,-0.493000001f);
					}



					// [B A C K   D O O R S] Collider
                        		var backdoor = Instance.transform.GetChild(6);
					if(firstSpawn)
					{
						backdoor.localPosition = new Vector3(-0.941999972f,0.061999999f);
					}
					backdoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.526052952f,0.956613243f),
						new Vector2(-0.634959579f,0.960857451f),
						new Vector2(-0.704040289f,0.237933964f),
						new Vector2(-0.750746846f,0.173921138f),
						new Vector2(-0.751077831f,-0.278744549f),
						new Vector2(-0.538576186f,-0.346046656f),
						new Vector2(-0.360663831f,-0.475129724f),
						new Vector2(-0.235588253f,-0.700687826f),
						new Vector2(-0.182929218f,-0.930152893f),
						new Vector2(0.69039458f,-0.951461613f),
						new Vector2(0.760850668f,-0.810671628f),
						new Vector2(0.754887581f,0.0937640592f),
						new Vector2(0.678371668f,0.237998664f)
					});

					// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector3(0.379999995f,0.061999999f);
					}
					frontdoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.890313148f,0.956764042f),
						new Vector2(-0.726450205f,0.228538424f),
						new Vector2(-0.622114241f,0.0878518149f),
						new Vector2(-0.627637267f,-0.782742918f),
						new Vector2(-0.681767166f,-0.952343047f),
						new Vector2(0.798514426f,-0.950340331f),
						new Vector2(0.883553505f,-0.820919812f),
						new Vector2(0.876056552f,0.103437342f),
						new Vector2(0.816622615f,0.250141472f),
						new Vector2(0.116845265f,0.956764162f)
					});

					// [B O N N E T] Collider
                        		var bonnet = Instance.transform.GetChild(3);
					if(firstSpawn)
					{
						bonnet.localPosition = new Vector3(2.13899994f,0.144999996f);
					}
					bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.950956643f,0.163196981f),
						new Vector2(-0.891807675f,0.00664353371f),
						new Vector2(-0.884575427f,-0.155734479f),
						new Vector2(0.946775258f,-0.156835198f),
						new Vector2(0.926026344f,-0.0751689449f),
						new Vector2(0.796904624f,0.00539290812f),
						new Vector2(0.290563315f,0.0949858502f)
					});

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(1.73804271f,-1.14220166f),
						new Vector2(3.34843278f,-1.06070113f),
						new Vector2(3.28001523f,-0.958691478f),
						new Vector2(3.29000998f,-0.328603238f),
						new Vector2(3.1486764f,-0.277451456f),
						new Vector2(3.06395578f,0.0211801529f),
						new Vector2(1.39338553f,0.0155553073f),
						new Vector2(1.29451263f,0.140850067f),
						new Vector2(1.28798199f,0.300596386f),
						new Vector2(0.476242006f,1.15638554f),
						new Vector2(-2.54329109f,1.16147923f),
						new Vector2(-2.6220994f,1.09099388f),
						new Vector2(-2.65172482f,1.07949591f),
						new Vector2(-2.67625666f,1.05897212f),
						new Vector2(-2.67606926f,0.975376308f),
						new Vector2(-2.7324121f,0.841844857f),
						new Vector2(-3.12599158f,0.306797028f),
						new Vector2(-3.20350766f,0.244792372f),
						new Vector2(-3.18838596f,-0.28494069f),
						new Vector2(-3.35829711f,-0.340038568f),
						new Vector2(-3.3419795f,-0.593719363f),
						new Vector2(-3.26379633f,-0.849713445f),
						new Vector2(-2.69886422f,-0.903023362f),
						new Vector2(-1.33515942f,-1.15267205f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
					{
						new Vector2(-1.21271777f,-0.461411238f),
						new Vector2(-1.42410147f,-0.26466924f),
						new Vector2(-1.6906265f,-0.163002074f),
						new Vector2(-1.69511008f,0.194999993f),
						new Vector2(-1.61491323f,0.308467984f),
						new Vector2(-1.59603977f,0.567231596f),
						new Vector2(-1.57477236f,0.768148959f),
						new Vector2(-1.56415665f,0.900612235f),
						new Vector2(-1.55733228f,1.00213861f),
						new Vector2(0.524652243f,1.00767994f),
						new Vector2(1.21567464f,0.266784668f),
						new Vector2(1.26546466f,0.145467401f),
						new Vector2(1.25389051f,-0.749664247f),
						new Vector2(1.1963073f,-0.8681494f),
						new Vector2(-0.7305547f,-0.866896987f),
						new Vector2(-1.07574511f,-0.851406574f),
						new Vector2(-1.14124274f,-0.673394978f)
					});
                        	}
			}
		);
    		//Ferrari F40
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Ferrari F40" + Modtag,
                    		NameToOrderByOverride = "CACC Ferrari F40",
                    		DescriptionOverride = "<color=orange>[Idea by: Klej]<color=white>" + "\nClassic of Ferrari cars.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Ferrari F40/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -4750f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -4750f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(6).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Ferrari F40/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Ferrari F40/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-2.28800011f,-0.558000028f);
                        		wheels[1].anchor = new Vector2(1.898f,-0.558000028f);

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Ferrari F40/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Ferrari F40/Background.png");
                        		CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/Ferrari F40/Front Doors.png");
                        		CarSprite.Bonnet = ModAPI.LoadSprite("Vehicles/Ferrari F40/Bonnet.png");
                        		CarSprite.Boot = ModAPI.LoadSprite("Vehicles/Ferrari F40/Boot.png");

                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/Ferrari F40/Blue/Body.png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/Ferrari F40/Background.png");
                        		CarSprite1.FrontDoor = ModAPI.LoadSprite("Vehicles/Ferrari F40/Blue/Front Doors.png");
                        		CarSprite1.Bonnet = ModAPI.LoadSprite("Vehicles/Ferrari F40/Blue/Bonnet.png");
                        		CarSprite1.Boot = ModAPI.LoadSprite("Vehicles/Ferrari F40/Blue/Boot.png");

                        		var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite2.Body = ModAPI.LoadSprite("Vehicles/Ferrari F40/Black/Body.png");
                        		CarSprite2.Background = ModAPI.LoadSprite("Vehicles/Ferrari F40/Background.png");
                        		CarSprite2.FrontDoor = ModAPI.LoadSprite("Vehicles/Ferrari F40/Black/Front Doors.png");
                        		CarSprite2.Bonnet = ModAPI.LoadSprite("Vehicles/Ferrari F40/Black/Bonnet.png");
                        		CarSprite2.Boot = ModAPI.LoadSprite("Vehicles/Ferrari F40/Black/Boot.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
						,CarSprite1
						,CarSprite2
                        		};


                        		var engine = Instance.transform.GetChild(7);
					engine.GetComponent<Rigidbody2D>().mass = 0.1f;
					engine.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
					engine.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(-2.55599999f,-0.00999999978f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(-1.40199995f,-0.476000011f);
					}

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(-0.252999991f,-0.0130000003f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Chevrolet Corvette ZL1/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
					part2.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.362319529f,0.61819011f),
						new Vector2(-0.436649382f,0.617118895f),
						new Vector2(-0.505624712f,0.565665781f),
						new Vector2(-0.503759861f,0.329081357f),
						new Vector2(-0.434651792f,-0.00027410686f),
						new Vector2(-0.235138997f,-0.526065648f),
						new Vector2(-0.145197242f,-0.5342834f),
						new Vector2(-0.148766071f,-0.612868726f),
						new Vector2(0.383648574f,-0.612868726f),
						new Vector2(0.407876402f,-0.526735842f),
						new Vector2(0.501180708f,-0.477414608f),
						new Vector2(0.490909338f,-0.337690771f),
						new Vector2(0.437561452f,-0.235854194f),
						new Vector2(0.0373045057f,-0.381144792f),
						new Vector2(-0.155179441f,-0.0750672519f),
						new Vector2(-0.277865946f,0.237931818f),
						new Vector2(-0.302002251f,0.560797632f)		
					});

					// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector3(0.126000002f,0.064999997f);
					}
					frontdoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.115259297f,0.67486769f),
						new Vector2(-0.189129785f,0.72173363f),
						new Vector2(-0.942837119f,0.718863845f),
						new Vector2(-0.999606609f,0.670906603f),
						new Vector2(-0.904246569f,-0.301493168f),
						new Vector2(-0.800375819f,-0.512908876f),
						new Vector2(-0.634126544f,-0.669612706f),
						new Vector2(0.0581298769f,-0.71953398f),
						new Vector2(0.988403678f,-0.725523472f),
						new Vector2(1.00727618f,0.0899880752f),
						new Vector2(0.868051648f,0.151894569f)
					});

					// [B O O T] Collider
                        		var boot = Instance.transform.GetChild(4);
					if(firstSpawn)
					{
						boot.localPosition = new Vector3(-2.50399995f,0.291999996f);
					}
                        		boot.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(1.01999998f,0.330000013f);
                        		boot.gameObject.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D()
                        		{
                            			min = 0,
                            			max = 135
                        		};
					boot.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.184179187f,0.106507629f),
						new Vector2(-0.449856311f,0.098452501f),
						new Vector2(-0.566973686f,0.265866518f),
						new Vector2(-0.58758384f,0.496526897f),
						new Vector2(-1.04942131f,0.503707945f),
						new Vector2(-1.03995395f,-0.49936977f),
						new Vector2(-0.303058863f,-0.492139518f),
						new Vector2(-0.0701364428f,-0.217010245f),
						new Vector2(0.251926482f,-0.135070875f),
						new Vector2(0.579237103f,-0.238644302f),
						new Vector2(1.02772903f,0.387763411f)
					});

					// [B O N N E T] Collider
                        		var bonnet = Instance.transform.GetChild(3);
					if(firstSpawn)
					{
						bonnet.localPosition = new Vector3(2.31299996f,-0.289000005f);
					}
                        		bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(1.08000004f,-0.479999989f);
                        		bonnet.gameObject.GetComponent<HingeJoint2D>().limits = new JointAngleLimits2D()
                        		{
                            			min = 0,
                            			max = 135
                        		};
					bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.377864361f,0.295489609f),
						new Vector2(-0.348451853f,0.496169508f),
						new Vector2(-1.24617839f,0.541643739f),
						new Vector2(-1.21103334f,0.00818829797f),
						new Vector2(-0.910020947f,0.00425107777f),
						new Vector2(-0.884899557f,0.157945603f),
						new Vector2(-0.629428864f,0.333416343f),
						new Vector2(-0.404533148f,0.380392134f),
						new Vector2(-0.160058737f,0.316877723f),
						new Vector2(0.0747785568f,0.115864009f),
						new Vector2(0.220642984f,-0.53443265f),
						new Vector2(1.24799156f,-0.528746486f),
						new Vector2(1.17154455f,-0.43057403f),
						new Vector2(1.15521574f,-0.209933341f),
						new Vector2(0.921928644f,0.0408090055f)
					});

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(1.1620971f,0.174242973f),
						new Vector2(0.274293661f,0.767946839f),
						new Vector2(0.0335629657f,0.844319344f),
						new Vector2(-0.978051364f,0.839163661f),
						new Vector2(-1.44405127f,0.728340805f),
						new Vector2(-1.69959021f,0.431886524f),
						new Vector2(-1.8828721f,0.246911883f),
						new Vector2(-2.4632771f,-0.219630793f),
						new Vector2(-3.55057454f,-0.214507729f),
						new Vector2(-3.54532218f,-0.588234723f),
						new Vector2(-3.18025041f,-0.698283076f),
						new Vector2(-1.56673145f,-0.806510925f),
						new Vector2(1.26153302f,-0.800319672f),
						new Vector2(1.3732419f,-0.251730978f),
						new Vector2(1.21506739f,-0.249036133f)

					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
					{
						new Vector2(-0.763763368f,-0.170686081f),
						new Vector2(-0.75973016f,-0.0089500621f),
						new Vector2(-0.777890921f,0.345034719f),
						new Vector2(-0.827671647f,0.756063402f),
						new Vector2(0.0552267879f,0.753770709f),
						new Vector2(0.277810484f,0.670135617f),
						new Vector2(1.08822978f,0.121390402f),
						new Vector2(1.09623766f,-0.629463553f),
						new Vector2(-0.471482545f,-0.617160201f),
						new Vector2(-0.600697279f,-0.502812982f),
						new Vector2(-0.762068808f,-0.236670911f)
					});
                        	}
			}
		);
    		//Toyota
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Toyota Hilux 1995" + Modtag,
                    		NameToOrderByOverride = "CACC Toyota Hilux 1995",
                    		DescriptionOverride = "<color=yellow>[By: Creator]<color=white>" + "\nPickup that can transport quite a bit.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -3175f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -3175f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(6).gameObject.SetActive(false);
                        		Instance.transform.GetChild(4).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-1.66999996f,-1.01300001f);
                        		wheels[1].anchor = new Vector2(2.58400011f,-1.01300001f);

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Background.png");
                        		CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Front Doors.png");
                        		CarSprite.Bonnet = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Bonnet.png");

                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Olive/Body.png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Background.png");
                        		CarSprite1.FrontDoor = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Olive/Front Doors.png");
                        		CarSprite1.Bonnet = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Olive/Bonnet.png");

                        		var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite2.Body = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Dark Blue/Body.png");
                        		CarSprite2.Background = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Background.png");
                        		CarSprite2.FrontDoor = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Dark Blue/Front Doors.png");
                        		CarSprite2.Bonnet = ModAPI.LoadSprite("Vehicles/Toyota Hilux 1995/Dark Blue/Bonnet.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
						,CarSprite1
						,CarSprite2
                        		};


                        		var engine = Instance.transform.GetChild(7);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(2.51099992f,-0.356000006f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(-0.423999995f,-0.532000005f);
					}

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(0.488000005f,-0.199000001f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl1 = part2.AddComponent<BoxCollider2D>();
					boxColl1.offset = new Vector2(-0.279263079f,0.00575792789f);
					boxColl1.size = new Vector2(0.19362998f,1.35521626f);
                            		var boxColl2 = part2.AddComponent<BoxCollider2D>();
					boxColl2.offset = new Vector2(0.0918133259f,-0.533767998f);
					boxColl2.size = new Vector2(0.578393221f,0.273626357f);


					// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector3(0.870000005f,0f);
					}
					frontdoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.788952112f,0.898520291f),
						new Vector2(-0.802297115f,-0.894931614f),
						new Vector2(0.804436803f,-0.895578802f),
						new Vector2(0.79694891f,0.0743274018f),
						new Vector2(0.64149487f,0.342476457f),
						new Vector2(0.0559865981f,0.89932543f)
					});

					// [B O N N E T] Collider
                        		var bonnet = Instance.transform.GetChild(3);
					if(firstSpawn)
					{
						bonnet.localPosition = new Vector3(2.63700008f,0.0120000001f);
					}
                        		bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.807976007f,0.111375317f);
					bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.235141605f,0.0536037758f),
						new Vector2(-0.828381538f,0.14426212f),
						new Vector2(-0.828381777f,0.0906366482f),
						new Vector2(0.224173427f,0.00281169638f),
						new Vector2(0.64977932f,-0.0682066604f),
						new Vector2(0.745438337f,-0.140701443f),
						new Vector2(0.828613281f,-0.141275659f),
						new Vector2(0.719387054f,-0.030415751f)
					});

                        		wheels[0].suspension = new JointSuspension2D()
                        		{
                            			frequency = 7f,
                            			angle = 90f,
                            			dampingRatio = 0.7f
                        		};

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 3;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(3.46753883f,-0.415828317f),
						new Vector2(3.47783899f,-0.0937253237f),
						new Vector2(3.24939442f,0.00707710255f),
						new Vector2(1.77004504f,0.156888783f),
						new Vector2(1.60033441f,0.421487272f),
						new Vector2(1.07963073f,0.92342639f),
						new Vector2(0.809735656f,1.01162994f),
						new Vector2(0.0194675624f,1.01107025f),
						new Vector2(-0.0698037595f,0.923438787f),
						new Vector2(-0.0949999988f,0.194999993f),
						new Vector2(-0.19095546f,0.187753141f),
						new Vector2(-0.193691969f,-0.645410061f),
						new Vector2(-3.23208618f,-0.648219109f),
						new Vector2(-3.22965002f,0.180734128f),
						new Vector2(-3.26528454f,0.180978909f),
						new Vector2(-3.32907295f,0.128663629f),
						new Vector2(-3.32100105f,-0.540196955f),
						new Vector2(-3.26753759f,-0.733726263f),
						new Vector2(-3.55493307f,-0.732334435f),
						new Vector2(-3.52093506f,-0.901294827f),
						new Vector2(-3.17946744f,-0.899229705f),
						new Vector2(-3.04342175f,-0.746630192f),
						new Vector2(-1.03002536f,-0.838524401f),
						new Vector2(-0.155446947f,-0.8448627f),
						new Vector2(-0.117345437f,-0.825125635f),
						new Vector2(-0.0729208291f,-1.0157603f),
						new Vector2(1.88626397f,-1.01037991f),
						new Vector2(3.33151245f,-0.86806488f),
						new Vector2(3.55590749f,-0.841925621f),
						new Vector2(3.55283022f,-0.704233885f),
						new Vector2(3.37455487f,-0.699348748f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
					{
						new Vector2(0.0694165379f,0.179443017f),
						new Vector2(0.099719733f,0.216048956f),
						new Vector2(0.0963126794f,0.864524961f),
						new Vector2(0.252606332f,0.862540483f),
						new Vector2(0.900367737f,0.865821302f),
						new Vector2(0.986655533f,0.822179198f),
						new Vector2(1.4956708f,0.32997483f),
						new Vector2(1.63782644f,0.0717411935f),
						new Vector2(1.66527772f,-0.167513385f),
						new Vector2(1.67013991f,-0.868995309f),
						new Vector2(0.0657445416f,-0.870790899f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(2, new Vector2[]
					{
						new Vector2(-0.985004306f,-0.691197395f),
						new Vector2(-1.29321861f,-0.266286314f),
						new Vector2(-2.03029394f,-0.265500039f),
						new Vector2(-2.33286119f,-0.676433682f)
					});
                        	}
			}
		);
    		//Toyota
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Opel Blitz" + Modtag,
                    		NameToOrderByOverride = "CACC Opel Blitz",
                    		DescriptionOverride = "<color=orange>[Idea by: Balion]<color=white>" + "\nWorld war 2 truck.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Opel Blitz/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -3175f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -3175f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(6).gameObject.SetActive(false);
                        		Instance.transform.GetChild(4).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Opel Blitz/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Opel Blitz/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-2.75399995f,-1.46099994f);
                        		wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.7f;
                        		wheels[1].anchor = new Vector2(2.83899999f,-1.46099994f);
                        		wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.7f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Opel Blitz/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Opel Blitz/Background.png");
                        		CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/Opel Blitz/Front Doors.png");
                        		CarSprite.Bonnet = ModAPI.LoadSprite("Vehicles/Opel Blitz/Bonnet.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
                        		};


                        		var engine = Instance.transform.GetChild(7);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(2.88400006f,-0.43900001f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					gastank.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Opel Blitz/Gastank.png");
					gastank.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(-0.214000002f,-0.898999989f);
					}

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(1.02600002f,0.0460000001f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl1 = part2.AddComponent<BoxCollider2D>();
					boxColl1.offset = new Vector2(-0.279263079f,0.00575792789f);
					boxColl1.size = new Vector2(0.19362998f,1.35521626f);
                            		var boxColl2 = part2.AddComponent<BoxCollider2D>();
					boxColl2.offset = new Vector2(0.0918133259f,-0.533767998f);
					boxColl2.size = new Vector2(0.578393221f,0.273626357f);

                        		GameObject container = new GameObject("Container");
                        		container.transform.parent = body;
                        		container.transform.localScale = Vector3.one;
                        		container.transform.localPosition = new Vector3(-2.3499999f,-0.120000036f);
                        		SpriteRenderer containerRenderer = container.AddComponent<SpriteRenderer>();
                        		containerRenderer.sprite = ModAPI.LoadSprite("Vehicles/Opel Blitz/Back Container.png");
                        		containerRenderer.sortingLayerName = "Foreground";
                        		container.layer = LayerMask.NameToLayer("Objects");
                        		container.AddComponent<Rigidbody2D>().mass = 10f;
                        		FixedJoint2D fixedJoint2 = container.AddComponent<FixedJoint2D>();
                        		fixedJoint2.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint2.breakForce = 5750f;
                        		container.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        		container.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxCollcontainer1 = container.AddComponent<BoxCollider2D>();
					boxCollcontainer1.offset = new Vector2(0.0057861805f,-0.429599285f);
					boxCollcontainer1.size = new Vector2(5.37484503f,0.116029948f);
                            		var boxCollcontainer2 = container.AddComponent<BoxCollider2D>();
					boxCollcontainer2.offset = new Vector2(-2.64593601f,-0.00581896305f);
					boxCollcontainer2.size = new Vector2(0.0714006424f,0.963790536f);
                            		var boxCollcontainer3 = container.AddComponent<BoxCollider2D>();
					boxCollcontainer3.offset = new Vector2(2.65765238f,-0.00581896305f);
					boxCollcontainer3.size = new Vector2(0.0695428848f,0.963790536f);


					// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector3(1.199f,0.150000006f);
					}
					frontdoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.431131244f,0.858029008f),
						new Vector2(0.329924256f,0.9022457f),
						new Vector2(-0.693432927f,0.902937233f),
						new Vector2(-0.686185896f,-0.894740224f),
						new Vector2(0.696940184f,-0.889986694f),
						new Vector2(0.699802995f,0.292449117f),
						new Vector2(0.497368991f,0.779785752f)
					});

					// [B O N N E T] Collider
                        		var bonnet = Instance.transform.GetChild(3);
					if(firstSpawn)
					{
						bonnet.localPosition = new Vector3(2.97099996f,0.140000001f);
					}
                        		bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.807976007f,0.111375317f);
					bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.610465765f,0.239610419f),
						new Vector2(0.406709045f,0.27044338f),
						new Vector2(-0.785626292f,0.275629699f),
						new Vector2(-0.773063898f,0.174492553f),
						new Vector2(-0.70356977f,0.0729545355f),
						new Vector2(-0.634967446f,-0.266921222f),
						new Vector2(0.788798451f,-0.266266167f),
						new Vector2(0.788798451f,-0.136266157f),
						new Vector2(0.711962819f,0.103038065f)
					});

                        		wheels[0].suspension = new JointSuspension2D()
                        		{
                            			frequency = 8f,
                            			angle = 90f,
                            			dampingRatio = 0.7f
                        		};
                        		wheels[1].suspension = new JointSuspension2D()
                        		{
                            			frequency = 8f,
                            			angle = 90f,
                            			dampingRatio = 0.7f
                        		};

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(1.83206415f,-1.13099456f),
						new Vector2(1.90663397f,-1.13038111f),
						new Vector2(1.90385842f,-1.18881106f),
						new Vector2(3.61596727f,-1.12405527f),
						new Vector2(4.12554979f,-1.12401605f),
						new Vector2(4.13167953f,-0.901051521f),
						new Vector2(4.01963425f,-0.898195863f),
						new Vector2(3.81415248f,0.244482696f),
						new Vector2(3.72541523f,0.383647442f),
						new Vector2(3.58939552f,0.38429141f),
						new Vector2(3.70291066f,0.187419862f),
						new Vector2(3.72512054f,-0.048104614f),
						new Vector2(2.3550818f,-0.0388934389f),
						new Vector2(2.18440008f,0.40646556f),
						new Vector2(1.96681619f,0.407785326f),
						new Vector2(1.8525368f,0.761755884f),
						new Vector2(1.6462965f,1.09344935f),
						new Vector2(1.49944949f,1.15251255f),
						new Vector2(0.483056456f,1.15137219f),
						new Vector2(0.394292355f,1.09285069f),
						new Vector2(0.378561974f,-0.657898366f),
						new Vector2(-1.92982101f,-0.644841313f),
						new Vector2(-2.29598045f,-0.331618041f),
						new Vector2(-2.61203909f,-0.220695198f),
						new Vector2(-2.88665938f,-0.22168988f),
						new Vector2(-3.2669301f,-0.360232711f),
						new Vector2(-3.53501344f,-0.648192525f),
						new Vector2(-4.13603354f,-0.648675382f),
						new Vector2(-4.0079546f,-1.00893605f),
						new Vector2(-3.72895122f,-1.01101446f),
						new Vector2(-3.70938468f,-1.15422034f),
						new Vector2(-1.78218353f,-1.15423024f),
						new Vector2(-1.77891898f,-1.01045763f),
						new Vector2(0.590531826f,-1.01450253f),
						new Vector2(0.601235747f,-1.12307441f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
					{
						new Vector2(0.52663964f,0.979728699f),
						new Vector2(1.50890982f,0.984881163f),
						new Vector2(1.6143961f,0.940218449f),
						new Vector2(1.87553513f,0.425224841f),
						new Vector2(1.87766576f,-0.637117386f),
						new Vector2(0.527204335f,-0.64249289f)
					});
                        	}
			}
		);
    		//Golf Cart
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Golf Cart " + Modtag,
                    		NameToOrderByOverride = "CACC Golf Cart",
                    		DescriptionOverride = "\n<color=yellow>[By: Creator]<color=white>" + "\nGolf cart, you can pack things into it's ,,basket'' at the back.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Golf Cart/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -1250f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -1250f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(6).gameObject.SetActive(false);
                        		Instance.transform.GetChild(5).gameObject.SetActive(false);
                        		Instance.transform.GetChild(4).gameObject.SetActive(false);
                        		Instance.transform.GetChild(3).gameObject.SetActive(false);

                           		body.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 3);

					var ChairSprite = ModAPI.LoadSprite("Vehicles/Golf Cart/Chair.png", 1f);
					
					if(body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 0)
					{
						ChairSprite = ModAPI.LoadSprite("Vehicles/Golf Cart/Chair.png", 1f);
					}
					if(body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 1)
					{
						ChairSprite = ModAPI.LoadSprite("Vehicles/Golf Cart/Black/Chair.png", 1f);
					}
					if(body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 2)
					{
						ChairSprite = ModAPI.LoadSprite("Vehicles/Golf Cart/Red/Chair.png", 1f);
					}

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Golf Cart/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Golf Cart/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-0.586000025f,-0.85799998f);
                        		wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.28f;
                        		wheels[1].anchor = new Vector2(1.44000006f,-0.85799998f);
                        		wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.28f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Golf Cart/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Golf Cart/Background.png");

                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/Golf Cart/Black/Body.png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/Golf Cart/Background.png");

                        		var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite2.Body = ModAPI.LoadSprite("Vehicles/Golf Cart/Red/Body.png");
                        		CarSprite2.Background = ModAPI.LoadSprite("Vehicles/Golf Cart/Background.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
						,CarSprite1
						,CarSprite2
                        		};


                        		var engine = Instance.transform.GetChild(7);
                        		engine.localScale = new Vector3(0.39f, 0.39f);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(1.31400001f,-0.433999985f);
					}
                        		var gastank = Instance.transform.GetChild(8);
                        		gastank.localScale = new Vector3(0.5f, 0.5f);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(-0.602999985f,-0.48300001f);
					}

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(0.189999998f,-0.134000003f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ChairSprite;
                        		part2Renderer.sortingLayerName = "Bottom";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl1 = part2.AddComponent<BoxCollider2D>();
					boxColl1.offset = new Vector2(-0.272686303f,0.0274516344f);
					boxColl1.size = new Vector2(0.129931003f,1.13642216f);
                            		var boxColl2 = part2.AddComponent<BoxCollider2D>();
					boxColl2.offset = new Vector2(0.0491062701f,-0.473525107f);
					boxColl2.size = new Vector2(0.630759299f,0.261635542f);


                        		wheels[0].suspension = new JointSuspension2D()
                        		{
                            			frequency = 4f,
                            			angle = 90f,
                            			dampingRatio = 0.7f
                        		};
                        		wheels[1].suspension = new JointSuspension2D()
                        		{
                            			frequency = 4f,
                            			angle = 90f,
                            			dampingRatio = 0.7f
                        		};

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(1.12488937f,0.855394065f),
						new Vector2(-0.808207035f,0.857642055f),
						new Vector2(-0.907899082f,0.795820713f),
						new Vector2(-0.901557028f,0.733540237f),
						new Vector2(-0.338366121f,0.731415808f),
						new Vector2(-0.324799657f,-0.224466503f),
						new Vector2(-0.376158267f,-0.227500603f),
						new Vector2(-1.10592461f,-0.227690637f),
						new Vector2(-1.13021863f,-0.621911645f),
						new Vector2(-1.46027672f,-0.619050682f),
						new Vector2(-1.60560119f,-0.337987542f),
						new Vector2(-1.59009385f,-0.166294336f),
						new Vector2(-1.65510845f,-0.229018986f),
						new Vector2(-1.63731265f,-0.348067164f),
						new Vector2(-1.4708668f,-0.650837898f),
						new Vector2(-1.35144532f,-0.694189966f),
						new Vector2(-1.35273373f,-0.767087221f),
						new Vector2(-0.989300787f,-0.768864155f),
						new Vector2(-0.176090568f,-0.854409099f),
						new Vector2(1.00187933f,-0.853880346f),
						new Vector2(1.16108716f,-0.816865861f),
						new Vector2(1.64107633f,-0.488293469f),
						new Vector2(1.48905516f,-0.239671707f),
						new Vector2(1.30239868f,-0.133844346f),
						new Vector2(1.00355947f,0.72830677f),
						new Vector2(1.20838392f,0.745323718f),
						new Vector2(1.21687579f,0.793469727f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
					{
						new Vector2(0.0662202984f,-0.741841793f),
						new Vector2(-0.144391418f,-0.687550068f),
						new Vector2(-0.290414661f,-0.221795544f),
						new Vector2(-0.305499703f,0.740579009f),
						new Vector2(0.961593449f,0.735319495f),
						new Vector2(1.22218013f,-0.118676275f),
						new Vector2(1.15241003f,-0.394486308f),
						new Vector2(1.07215679f,-0.434497535f),
						new Vector2(1.03813922f,-0.638192892f),
						new Vector2(0.987836123f,-0.739835262f)
					});
                        	}
			}
		);
    		//Dirt bike
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Dirt bike" + Modtag,
                    		NameToOrderByOverride = "CACC Dirt bike",
                    		DescriptionOverride = "<color=blue>[Idea by: blue shibe]<color=white>" + "\nDirt bike.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Motorcross/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -2750f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -2750f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(6).gameObject.SetActive(false);
                        		Instance.transform.GetChild(5).gameObject.SetActive(false);
                        		Instance.transform.GetChild(4).gameObject.SetActive(false);
                        		Instance.transform.GetChild(3).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Motorcross/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Motorcross/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-0.828999996f,-0.518999994f);
                        		wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.41f;
                        		wheels[1].anchor = new Vector2(0.941999972f,-0.518999994f);
                        		wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.41f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Motorcross/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Motorcross/Background.png");

                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/Motorcross/Body [1].png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/Motorcross/Background.png");

                        		var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite2.Body = ModAPI.LoadSprite("Vehicles/Motorcross/Body [2].png");
                        		CarSprite2.Background = ModAPI.LoadSprite("Vehicles/Motorcross/Background.png");

                        		var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite3.Body = ModAPI.LoadSprite("Vehicles/Motorcross/Body [3].png");
                        		CarSprite3.Background = ModAPI.LoadSprite("Vehicles/Motorcross/Background.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
						,CarSprite1
						,CarSprite2
						,CarSprite3
                        		};

                               			

                        		var engine = Instance.transform.GetChild(7);
					engine.GetComponent<BoxCollider2D>().offset = new Vector2(-0.00535523891f,-0.114245057f);
					engine.GetComponent<BoxCollider2D>().size = new Vector2(0.438472331f,0.35280633f);
					engine.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Motorcross/Engine.png");
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(0.0270000007f,-0.197999999f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					gastank.GetComponent<BoxCollider2D>().offset = new Vector2(-0.00384683907f,-0.00307747722f);
					gastank.GetComponent<BoxCollider2D>().size = new Vector2(0.32465151f,0.176169038f);
					gastank.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Motorcross/Gastank.png");
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(0.316000015f,0.243000001f);
					}

                        		GameObject part2 = new GameObject("Pipe");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(-0.287f,-0.0590000004f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Motorcross/Exhaust.png");
                        		part2Renderer.sortingLayerName = "Top";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 575f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
					part2.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.00448617339f,-0.164625123f),
						new Vector2(0.052603215f,-0.121538982f),
						new Vector2(0.0623166561f,-0.0795832872f),
						new Vector2(-0.164293438f,0.0176548138f),
						new Vector2(-0.511734784f,0.225336626f),
						new Vector2(-0.656350851f,0.227924064f),
						new Vector2(-0.625585079f,0.116430372f),
						new Vector2(-0.0831550658f,-0.16930595f)
					});
                            		HingeJoint2D hingeJoint = part2.AddComponent<HingeJoint2D>();
                            		hingeJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            		hingeJoint.anchor = new Vector2(0.606016994f,-0.180386335f);
                            		hingeJoint.breakForce = 1200f;
                            		hingeJoint.breakTorque = 1100f;
                            		hingeJoint.limits = new JointAngleLimits2D()
                            		{
                               			 min = -273.587f,
						 max = 3.027367f
					};
                            		hingeJoint.useLimits = true;

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.652412117f,0.193520933f),
						new Vector2(0.766423881f,0.201803982f),
						new Vector2(0.953913569f,0.224005312f),
						new Vector2(1.19991267f,0.151680946f),
						new Vector2(1.04960942f,0.258083045f),
						new Vector2(0.626908898f,0.290117353f),
						new Vector2(0.481628358f,0.503560901f),
						new Vector2(0.224977061f,0.604528189f),
						new Vector2(0.166124627f,0.576883376f),
						new Vector2(0.178832531f,0.486979127f),
						new Vector2(0.336901516f,0.471600145f),
						new Vector2(0.393644392f,0.410652697f),
						new Vector2(0.330111027f,0.349617332f),
						new Vector2(0.21767731f,0.344188303f),
						new Vector2(0.122867748f,0.364408076f),
						new Vector2(0.0404712409f,0.32226944f),
						new Vector2(-0.48786211f,0.28711164f),
						new Vector2(-0.62845856f,0.285100728f),
						new Vector2(-1.19715607f,0.315504134f),
						new Vector2(-1.1920687f,0.28275615f),
						new Vector2(-0.777897477f,0.219172686f),
						new Vector2(-0.640181482f,0.114306688f),
						new Vector2(-0.570779383f,0.00310144201f),
						new Vector2(-0.319999993f,-0.129999995f),
						new Vector2(-0.287107766f,-0.299967796f),
						new Vector2(-0.882946193f,-0.456592739f),
						new Vector2(-0.940007806f,-0.504168928f),
						new Vector2(-0.875123322f,-0.59645927f),
						new Vector2(-0.272411615f,-0.452700883f),
						new Vector2(-0.234246939f,-0.362650216f),
						new Vector2(-0.110156804f,-0.51478827f),
						new Vector2(0.0900847614f,-0.515185118f),
						new Vector2(0.257136524f,-0.369791031f),
						new Vector2(0.271680951f,-0.224033952f),
						new Vector2(0.42236641f,-0.0969134495f),
						new Vector2(0.562046409f,0.114917383f),
						new Vector2(0.917781293f,-0.576424539f),
						new Vector2(1.0131166f,-0.532027602f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
					{
						new Vector2(0.205567852f,-0.364533335f),
						new Vector2(0.0880911723f,-0.450017333f),
						new Vector2(-0.0789167881f,-0.44150123f),
						new Vector2(-0.149209931f,-0.361814469f),
						new Vector2(-0.166493282f,-0.211278901f),
						new Vector2(-0.0385366827f,-0.0715290383f),
						new Vector2(0.0938998759f,0.0577517301f),
						new Vector2(0.255062521f,0.0454215109f),
						new Vector2(0.315095067f,-0.0168557614f)
					});
                        		foreach (Collider2D collider in Instance.transform.GetChild(0).gameObject.GetComponentsInChildren<Collider2D>())
                                	{   
                                    		NoCollideWithBodyPart noCollide = Instance.transform.GetChild(0).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    		noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    		noCollide.Collider = collider;
                                	}
                        		foreach (Collider2D collider in Instance.transform.GetChild(7).gameObject.GetComponentsInChildren<Collider2D>())
                                	{   
                                    		NoCollideWithBodyPart noCollide = Instance.transform.GetChild(7).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    		noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    		noCollide.Collider = collider;
                                	}
                        		foreach (Collider2D collider in Instance.transform.GetChild(8).gameObject.GetComponentsInChildren<Collider2D>())
                                	{   
                                    		NoCollideWithBodyPart noCollide = Instance.transform.GetChild(8).gameObject.AddComponent<NoCollideWithBodyPart>();
                                    		noCollide.BodyPart = LimbBehaviour.BodyPart.Legs;
                                    		noCollide.Collider = collider;
                                	}
                        	}
			}
		);
    		//Bmw E30
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Bmw E36" + Modtag,
                    		NameToOrderByOverride = "CACC Bmw E30",
                    		DescriptionOverride = "<color=orange>[Idea by: Jose]<color=white>" + "\nBmw.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Bmw E30/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -3975f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -3975f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Bmw E30/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Bmw E30/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-1.94299996f,-0.859000027f);
                        		//wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.41f;
                        		wheels[1].anchor = new Vector2(2.39499998f,-0.859000027f);
                        		//wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.41f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Bmw E30/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Bmw E30/Background.png");
					CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/Bmw E30/Front Doors.png");
					CarSprite.BackDoor = ModAPI.LoadSprite("Vehicles/Bmw E30/Back Doors.png");
					CarSprite.Bonnet = ModAPI.LoadSprite("Vehicles/Bmw E30/Bonnet.png");
					CarSprite.Boot = ModAPI.LoadSprite("Vehicles/Bmw E30/Boot.png");

                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/Bmw E30/White/Body.png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/Bmw E30/Background.png");
					CarSprite1.FrontDoor = ModAPI.LoadSprite("Vehicles/Bmw E30/White/Front Doors.png");
					CarSprite1.BackDoor = ModAPI.LoadSprite("Vehicles/Bmw E30/White/Back Doors.png");
					CarSprite1.Bonnet = ModAPI.LoadSprite("Vehicles/Bmw E30/White/Bonnet.png");
					CarSprite1.Boot = ModAPI.LoadSprite("Vehicles/Bmw E30/White/Boot.png");

                        		var CarSprite2 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite2.Body = ModAPI.LoadSprite("Vehicles/Bmw E30/Black/Body.png");
                        		CarSprite2.Background = ModAPI.LoadSprite("Vehicles/Bmw E30/Background.png");
					CarSprite2.FrontDoor = ModAPI.LoadSprite("Vehicles/Bmw E30/Black/Front Doors.png");
					CarSprite2.BackDoor = ModAPI.LoadSprite("Vehicles/Bmw E30/Black/Back Doors.png");
					CarSprite2.Bonnet = ModAPI.LoadSprite("Vehicles/Bmw E30/Black/Bonnet.png");
					CarSprite2.Boot = ModAPI.LoadSprite("Vehicles/Bmw E30/Black/Boot.png");

                        		var CarSprite3 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite3.Body = ModAPI.LoadSprite("Vehicles/Bmw E30/Purple/Body.png");
                        		CarSprite3.Background = ModAPI.LoadSprite("Vehicles/Bmw E30/Background.png");
					CarSprite3.FrontDoor = ModAPI.LoadSprite("Vehicles/Bmw E30/Purple/Front Doors.png");
					CarSprite3.BackDoor = ModAPI.LoadSprite("Vehicles/Bmw E30/Purple/Back Doors.png");
					CarSprite3.Bonnet = ModAPI.LoadSprite("Vehicles/Bmw E30/Purple/Bonnet.png");
					CarSprite3.Boot = ModAPI.LoadSprite("Vehicles/Bmw E30/Purple/Boot.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite,
						CarSprite1,
						CarSprite2,
						CarSprite3
                        		};

                        		var engine = Instance.transform.GetChild(7);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(2.30999994f,-0.340000004f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(-2.09699988f,-0.400000006f);
					}

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(-0.898000002f,-0.0549999997f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl1 = part2.AddComponent<BoxCollider2D>();
					boxColl1.offset = new Vector2(-0.279263079f,0.00575792789f);
					boxColl1.size = new Vector2(0.19362998f,1.35521626f);
                            		var boxColl2 = part2.AddComponent<BoxCollider2D>();
					boxColl2.offset = new Vector2(0.0918133259f,-0.533767998f);
					boxColl2.size = new Vector2(0.578393221f,0.273626357f);

                        		GameObject part3 = new GameObject("Chair 2");
                        		part3.transform.parent = body;
                        		part3.transform.localScale = Vector3.one;
                        		part3.transform.localPosition = new Vector3(0.240999997f,-0.0549999997f);
                        		SpriteRenderer part3Renderer = part3.AddComponent<SpriteRenderer>();
                        		part3Renderer.sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Chair.png");
                        		part3Renderer.sortingLayerName = "Foreground";
                        		part3.layer = LayerMask.NameToLayer("Objects");
                        		part3.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint1 = part3.AddComponent<FixedJoint2D>();
                        		fixedJoint1.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint1.breakForce = 875f;
                        		part3.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part3.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl3 = part3.AddComponent<BoxCollider2D>();
					boxColl3.offset = new Vector2(-0.279263079f,0.00575792789f);
					boxColl3.size = new Vector2(0.19362998f,1.35521626f);
                            		var boxColl4 = part3.AddComponent<BoxCollider2D>();
					boxColl4.offset = new Vector2(0.0918133259f,-0.533767998f);
					boxColl4.size = new Vector2(0.578393221f,0.273626357f);
                               			
					// [B A C K   D O O R S] Collider
                        		var backdoor = Instance.transform.GetChild(6);
					if(firstSpawn)
					{
						backdoor.localPosition = new Vector3(-1.04499996f,0.0549999997f);
					}
					backdoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.378901511f,0.82881546f),
						new Vector2(-0.703584075f,0.542924762f),
						new Vector2(-0.825655222f,0.366263717f),
						new Vector2(-0.842656493f,0.236338019f),
						new Vector2(-0.749366403f,0.0578894541f),
						new Vector2(-0.691861749f,-0.171197295f),
						new Vector2(-0.381270409f,-0.387165457f),
						new Vector2(-0.285097122f,-0.536489606f),
						new Vector2(-0.242247358f,-0.823341727f),
						new Vector2(0.840551019f,-0.821907163f),
						new Vector2(0.834198952f,-0.433245867f),
						new Vector2(0.611358464f,0.829907417f)
					});

					// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector3(0.52700001f,0.0549999997f);
					}
					frontdoor.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.922204673f,0.824159145f),
						new Vector2(-0.742379427f,-0.00829182565f),
						new Vector2(-0.693452001f,-0.815880179f),
						new Vector2(0.924095154f,-0.815141082f),
						new Vector2(0.923060596f,-0.0062461067f),
						new Vector2(0.254465818f,0.628722787f),
						new Vector2(-0.103544772f,0.824542165f)
					});

					// [B O O T] Collider
                        		var boot = Instance.transform.GetChild(4);
					if(firstSpawn)
					{
						boot.localPosition = new Vector3(-2.99300003f,-0.0860000029f);
					}
                        		boot.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(0.465849638f,0.255529314f);
					boot.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.341258675f,0.285906285f),
						new Vector2(-0.43048352f,0.16846998f),
						new Vector2(-0.431119621f,-0.284398913f),
						new Vector2(-0.372256756f,-0.254216492f),
						new Vector2(-0.372026682f,0.166676804f),
						new Vector2(-0.311426371f,0.229896933f),
						new Vector2(0.489807308f,0.229101852f),
						new Vector2(0.488229454f,0.28588599f)
					});

					// [B O N N E T] Collider
                        		var bonnet = Instance.transform.GetChild(3);
					if(firstSpawn)
					{
						bonnet.localPosition = new Vector3(2.42799997f,-0.00100000005f);
					}
                        		bonnet.gameObject.GetComponent<HingeJoint2D>().anchor = new Vector2(-0.916571021f,0.140001699f);
					bonnet.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.460298061f,0.0840970129f),
						new Vector2(0.107780322f,0.139903277f),
						new Vector2(-0.940164626f,0.172900319f),
						new Vector2(-0.939060628f,0.118448555f),
						new Vector2(0.0936748981f,0.0911934823f),
						new Vector2(0.447131366f,0.0371011756f),
						new Vector2(0.884099782f,-0.132643417f),
						new Vector2(0.931604445f,-0.141759515f),
						new Vector2(0.880975783f,-0.0646565929f)
					});

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 3;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(3.22423172f,-0.911092281f),
						new Vector2(3.32913256f,-0.833562493f),
						new Vector2(3.34727097f,-0.569854438f),
						new Vector2(3.46111155f,-0.567894101f),
						new Vector2(3.48566151f,-0.461610675f),
						new Vector2(3.36765695f,-0.46278432f),
						new Vector2(3.39440966f,-0.149254799f),
						new Vector2(3.25637245f,-0.0320198275f),
						new Vector2(2.89579415f,0.0799999982f),
						new Vector2(2.20594072f,0.179957718f),
						new Vector2(1.38771737f,0.173665449f),
						new Vector2(0.845351338f,0.706698179f),
						new Vector2(0.437384605f,0.937197566f),
						new Vector2(-1.51396883f,0.942619801f),
						new Vector2(-1.78272283f,0.844891608f),
						new Vector2(-2.37052536f,0.227511674f),
						new Vector2(-2.50626373f,0.191788346f),
						new Vector2(-2.5376842f,-0.176743716f),
						new Vector2(-2.68144751f,-0.381908894f),
						new Vector2(-3.39806294f,-0.381567359f),
						new Vector2(-3.47977638f,-0.463300735f),
						new Vector2(-3.47952628f,-0.57124424f),
						new Vector2(-3.40579581f,-0.571339011f),
						new Vector2(-3.31499338f,-0.735255241f),
						new Vector2(-3.36206079f,-0.847952425f),
						new Vector2(-1.27833295f,-0.945886374f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
					{
						new Vector2(-1.25887775f,-0.747068882f),
						new Vector2(-1.31876707f,-0.427207261f),
						new Vector2(-1.47003639f,-0.248903036f),
						new Vector2(-1.71161628f,-0.121574759f),
						new Vector2(-1.84568334f,0.280870825f),
						new Vector2(-1.85665309f,0.417396665f),
						new Vector2(-1.7122215f,0.584882259f),
						new Vector2(-1.41852844f,0.86048764f),
						new Vector2(-0.462694436f,0.86633265f),
						new Vector2(-0.332828224f,0.208948284f),
						new Vector2(-0.267187715f,-0.0871020406f),
						new Vector2(-0.223786473f,-0.748955727f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(2, new Vector2[]
					{
						new Vector2(-0.132669896f,-0.743334174f),
						new Vector2(-0.175567105f,-0.087460205f),
						new Vector2(-0.375381619f,0.860090613f),
						new Vector2(0.31116581f,0.854797363f),
						new Vector2(0.537465811f,0.807236433f),
						new Vector2(0.823764741f,0.627503633f),
						new Vector2(1.42720163f,0.0436031818f),
						new Vector2(1.42937481f,-0.741677046f)
					});
                        	}
			}
		);
    		//Trolley
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Trolley" + Modtag,
                    		NameToOrderByOverride = "CACC Trolley",
                    		DescriptionOverride = "<color=blue>[GOOFY AHH]<color=white>" + "\nOh got it's armed",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Trolley/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);

                        		bool firstSpawn = (body.localPosition == Vector3.zero);

                        		Instance.transform.GetChild(3).gameObject.SetActive(false);
                        		Instance.transform.GetChild(4).gameObject.SetActive(false);
                        		Instance.transform.GetChild(5).gameObject.SetActive(false);
                        		Instance.transform.GetChild(6).gameObject.SetActive(false);
                        		Instance.transform.GetChild(7).gameObject.SetActive(false);
                        		Instance.transform.GetChild(8).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Trolley/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Trolley/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-0.64200002f,-0.688000023f);
                        		wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.11f;
                        		wheels[1].anchor = new Vector2(0.727000058f,-0.687999964f);
                        		wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.11f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Trolley/Body.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
                        		};

                        		var lmg = ModAPI.FindSpawnable("Soviet Submachine Gun");
                        		var lmgPrefab = lmg.Prefab;
                        		var GunObject = GameObject.Instantiate(lmgPrefab, Instance.transform.position, Instance.transform.rotation);
					GunObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Trolley/Gun.png");
                        		foreach(Collider2D Collider in GunObject.GetComponents<Collider2D>()) {
                                		GameObject.Destroy(Collider);
                            		}
                        		GunObject.transform.parent = body;
					GunObject.GetComponent<FirearmBehaviour>().barrelPosition = new Vector3(0.644999981f,0.122000001f);
					var boxGunColl1 = GunObject.AddComponent<BoxCollider2D>();
					boxGunColl1.offset = new Vector2(-0.322585583f,-0.0376020074f);
					boxGunColl1.size = new Vector2(0.212513685f,0.228952646f);
                            		GunObject.transform.localPosition = new Vector3(1.39499998f,0.623000026f);
                            		FixedJoint2D fixedJoint = GunObject.AddComponent<FixedJoint2D>();
                            		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            		fixedJoint.breakForce = 750f;

                        		var lmg2 = ModAPI.FindSpawnable("Soviet Submachine Gun");
                        		var lmg2Prefab = lmg2.Prefab;
                        		var GunObject2 = GameObject.Instantiate(lmg2Prefab, Instance.transform.position, Instance.transform.rotation);
					GunObject2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Trolley/Gun.png");
                        		foreach(Collider2D Collider in GunObject2.GetComponents<Collider2D>()) {
                                		GameObject.Destroy(Collider);
                            		}
                        		GunObject2.transform.parent = body;
					GunObject2.GetComponent<FirearmBehaviour>().barrelPosition = new Vector3(0.644999981f,0.122000001f);
					var boxGunColl2 = GunObject2.AddComponent<BoxCollider2D>();
					boxGunColl2.offset = new Vector2(-0.322585583f,-0.0376020074f);
					boxGunColl2.size = new Vector2(0.212513685f,0.228952646f);
                            		GunObject2.transform.localPosition = new Vector3(-0.409000009f,0.82099998f);
                            		FixedJoint2D fixedJoint1 = GunObject2.AddComponent<FixedJoint2D>();
                            		fixedJoint1.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            		fixedJoint1.breakForce = 750f;

                        		var rpg = ModAPI.FindSpawnable("Bazooka");
                        		var rpgPrefab = rpg.Prefab;
                        		var RPGobject = GameObject.Instantiate(rpgPrefab, Instance.transform.position, Instance.transform.rotation);
					RPGobject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Trolley/Launcher.png");
					RPGobject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        		foreach(Collider2D Collider in RPGobject.GetComponents<Collider2D>()) {
                                		GameObject.Destroy(Collider);
                            		}
                        		RPGobject.transform.parent = body;
					var boxGunColl3 = RPGobject.AddComponent<BoxCollider2D>();
					boxGunColl3.offset = new Vector2(-0.0330581069f,-0.0813737661f);
					boxGunColl3.size = new Vector2(0.716697097f,0.1805152f);
                            		RPGobject.transform.localPosition = new Vector3(0.565999985f,-0.263999999f);
                            		FixedJoint2D fixedJoint2 = RPGobject.AddComponent<FixedJoint2D>();
                            		fixedJoint2.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                            		fixedJoint2.breakForce = 750f;

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
                        		body.GetComponent<PolygonCollider2D>().pathCount = 1;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(1.01876521f,-0.51801765f),
						new Vector2(-0.726394653f,-0.47679314f),
						new Vector2(-0.687104285f,-0.343433172f),
						new Vector2(-0.402127892f,-0.341723233f),
						new Vector2(-0.350395143f,-0.289647698f),
						new Vector2(0.025786534f,-0.292921364f),
						new Vector2(1.04414332f,-0.196241692f),
						new Vector2(1.04245317f,0.486185014f),
						new Vector2(1.03210783f,0.486936748f),
						new Vector2(1.02720225f,-0.161869645f),
						new Vector2(0.0145493746f,-0.251747519f),
						new Vector2(-0.496237457f,-0.25111109f),
						new Vector2(-0.783223629f,0.702536285f),
						new Vector2(-1.03408587f,0.683891594f),
						new Vector2(-1.04352891f,0.601074457f),
						new Vector2(-0.816372275f,0.625404418f),
						new Vector2(-0.525509179f,-0.28341043f),
						new Vector2(-0.743662477f,-0.297592282f),
						new Vector2(-0.81779635f,-0.461374551f),
						new Vector2(-0.757003069f,-0.559151709f),
						new Vector2(-0.434199572f,-0.568561316f),
						new Vector2(1.06043351f,-0.566544473f)
					});
                        	}
			}
		);
    		//Kübelwagen
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "Kübelwagen" + Modtag,
                    		NameToOrderByOverride = "CACC Kübelwagen",
                    		DescriptionOverride = "<color=orange>[Idea by: FurrySlurry]<color=white>" + "\nWW2 Car based off Volkswagen Beetle.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/Kubelwagen/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -2250f;
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -2250f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                        		Instance.transform.GetChild(4).gameObject.SetActive(false);
                        		Instance.transform.GetChild(3).gameObject.SetActive(false);

					Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Kubelwagen/Wheel.png", 1f);
            				Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Kubelwagen/Wheel.png", 1f);                  

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-1.74100006f,-0.916999996f);
                        		//wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.57f;
                        		wheels[1].anchor = new Vector2(2.05599999f,-0.916999996f);
                        		//wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.57f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/Kubelwagen/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/Kubelwagen/Background.png");
                        		CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/Kubelwagen/Front Doors.png");
                        		CarSprite.BackDoor = ModAPI.LoadSprite("Vehicles/Kubelwagen/Back Doors.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
                        		};

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(-0.541000009f,-0.103f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Kubelwagen/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
					part2.AddComponent<PolygonCollider2D>();
					part2.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.3704485f,0.438385755f),
						new Vector2(-0.270647317f,-0.415514678f),
						new Vector2(0.367631793f,-0.415764183f),
						new Vector2(0.372408032f,-0.305075109f),
						new Vector2(-0.162861943f,-0.3071872f),
						new Vector2(-0.262836218f,0.436956048f),
					});

                        		GameObject part3 = new GameObject("Chair 2");
                        		part3.transform.parent = body;
                        		part3.transform.localScale = Vector3.one;
                        		part3.transform.localPosition = new Vector3(0.488999993f,-0.103f);
                        		SpriteRenderer part3Renderer = part3.AddComponent<SpriteRenderer>();
                        		part3Renderer.sprite = ModAPI.LoadSprite("Vehicles/Kubelwagen/Chair.png");
                        		part3Renderer.sortingLayerName = "Foreground";
                        		part3.layer = LayerMask.NameToLayer("Objects");
                        		part3.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint1 = part3.AddComponent<FixedJoint2D>();
                        		fixedJoint1.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint1.breakForce = 875f;
                        		part3.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part3.AddComponent<AudioSourceTimeScaleBehaviour>();
					part3.AddComponent<PolygonCollider2D>();
					part3.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(-0.3704485f,0.438385755f),
						new Vector2(-0.270647317f,-0.415514678f),
						new Vector2(0.367631793f,-0.415764183f),
						new Vector2(0.372408032f,-0.305075109f),
						new Vector2(-0.162861943f,-0.3071872f),
						new Vector2(-0.262836218f,0.436956048f),
					});

                        		var engine = Instance.transform.GetChild(7);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(2.2249999f,-0.398999989f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(-1.83099997f,-0.493000001f);
					}



					// [B A C K   D O O R S] Collider
                        		var backdoor = Instance.transform.GetChild(6);
					if(firstSpawn)
					{
						backdoor.localPosition = new Vector3(-0.402999997f,-0.115000002f);
					}
                        		foreach(PolygonCollider2D Collider in Instance.transform.GetChild(6).gameObject.GetComponents<PolygonCollider2D>())
                            		{
                                		GameObject.Destroy(Collider);
                            		}
					var doorColl1 = Instance.transform.GetChild(6).gameObject.AddComponent<BoxCollider2D>();
					doorColl1.offset = new Vector2(-0.00315189362f,-0.00157597661f);
					doorColl1.size = new Vector2(1.02559686f,0.867887676f);

					// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector3(0.624000013f,-0.115000002f);
					}
                        		foreach(PolygonCollider2D Collider in Instance.transform.GetChild(5).gameObject.GetComponents<PolygonCollider2D>())
                            		{
                                		GameObject.Destroy(Collider);
                            		}
					var doorColl2 = Instance.transform.GetChild(5).gameObject.AddComponent<BoxCollider2D>();
					doorColl2.offset = new Vector2(-0.00315189362f,-0.00157597661f);
					doorColl2.size = new Vector2(1.02559686f,0.867887676f);

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 1;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(2.25272655f,-0.974150896f),
						new Vector2(2.52186441f,-0.585369825f),
						new Vector2(2.94502187f,-0.509342253f),
						new Vector2(2.94868255f,-0.263959527f),
						new Vector2(2.66168833f,-0.197848886f),
						new Vector2(2.75661492f,0.0368523449f),
						new Vector2(1.74397469f,0.359776884f),
						new Vector2(1.67827523f,0.135952532f),
						new Vector2(1.28966928f,0.277308881f),
						new Vector2(0.992424846f,0.90634501f),
						new Vector2(0.848022759f,0.9078933f),
						new Vector2(1.14231551f,0.297561049f),
						new Vector2(1.14463711f,-0.54241389f),
						new Vector2(-0.902459621f,-0.54699719f),
						new Vector2(-0.901052654f,0.368908346f),
						new Vector2(-2.34036207f,0.36654526f),
						new Vector2(-2.56678104f,-0.0533185378f),
						new Vector2(-2.61181998f,-0.0593979917f),
						new Vector2(-2.79822278f,-0.237608522f),
						new Vector2(-2.74343896f,-0.326588571f),
						new Vector2(-2.75136471f,-0.506894112f),
						new Vector2(-2.66005373f,-0.523594856f),
						new Vector2(-2.55585217f,-0.651974916f),
						new Vector2(-2.47752094f,-0.906704187f),
						new Vector2(-1.01945472f,-0.97194463f),
						new Vector2(1.43943632f,-0.973258972f)
					});
                        	}
			}
		);
    		//ZIS-5
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Car"),
                    		NameOverride = "ZIS-5" + Modtag,
                    		NameToOrderByOverride = "CACC ZIS-5",
                    		DescriptionOverride = "<color=orange>[Idea by: Balion]<color=white>" + "\nSoviet WW2 truck.",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/ZIS-5/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
                        		var body = Instance.transform.GetChild(0);
                        		body.gameObject.GetComponent<CarBehaviour>().MotorSpeed = -2150f;
					//body.gameObject.AddComponent<CarRadioBehaviour>();
					var cSpeed = body.gameObject.AddComponent<ChangeSpeedBehaviour>();
					cSpeed.orgSpeed = -2150f;

                        		bool firstSpawn = (body.localPosition == Vector3.zero); 

                           		body.GetComponent<RandomCarTextureBehaviour>().chosenIndex = UnityEngine.Random.Range(0, 2);

                        		Instance.transform.GetChild(4).gameObject.SetActive(false);
                        		Instance.transform.GetChild(6).gameObject.SetActive(false);
					
					if(body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 0)
					{
						Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/ZIS-5/Wheel.png", 1f);
            					Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/ZIS-5/Wheel.png", 1f);  
					}               
					if(body.GetComponent<RandomCarTextureBehaviour>().chosenIndex == 1)
					{
						Instance.transform.Find("Wheel1").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/ZIS-5/Green/Wheel.png", 1f);
            					Instance.transform.Find("Wheel2").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/ZIS-5/Green/Wheel.png", 1f);  
					}      

                        		WheelJoint2D[] wheels = body.gameObject.GetComponents<WheelJoint2D>();
                        		wheels[0].anchor = new Vector2(-1.99300003f,-1.21000004f);
                        		wheels[0].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.71f;
                        		wheels[1].anchor = new Vector2(3.60800004f,-1.21000004f);
                        		wheels[1].connectedBody.gameObject.GetComponent<CircleCollider2D>().radius = 0.71f;

                        		var CarSprite = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite.Body = ModAPI.LoadSprite("Vehicles/ZIS-5/Body.png");
                        		CarSprite.Background = ModAPI.LoadSprite("Vehicles/ZIS-5/Background.png");
                        		CarSprite.FrontDoor = ModAPI.LoadSprite("Vehicles/ZIS-5/Front Doors.png");
                        		CarSprite.Bonnet = ModAPI.LoadSprite("Vehicles/ZIS-5/Bonnet.png");

                        		var CarSprite1 = new RandomCarTextureBehaviour.CarSprites();
                        		CarSprite1.Body = ModAPI.LoadSprite("Vehicles/ZIS-5/Green/Body.png");
                        		CarSprite1.Background = ModAPI.LoadSprite("Vehicles/ZIS-5/Green/Background.png");
                        		CarSprite1.FrontDoor = ModAPI.LoadSprite("Vehicles/ZIS-5/Green/Front Doors.png");
                        		CarSprite1.Bonnet = ModAPI.LoadSprite("Vehicles/ZIS-5/Green/Bonnet.png");

                        		body.gameObject.GetComponent<RandomCarTextureBehaviour>().Textures = new RandomCarTextureBehaviour.CarSprites[]
                        		{
                            			CarSprite
						,CarSprite1
                        		};

                        		var engine = Instance.transform.GetChild(7);
					if(firstSpawn)
					{
                            			engine.localPosition = new Vector3(3.08500004f,-0.510999978f);
					}
                        		var gastank = Instance.transform.GetChild(8);
					if(firstSpawn)
					{
                            			gastank.localPosition = new Vector3(0.860000014f,-0.989000022f);
					}

                        		GameObject part2 = new GameObject("Chair");
                        		part2.transform.parent = body;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(1.34200001f,0.00899999961f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Lada NIVA/Chair.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = body.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
                            		var boxColl1 = part2.AddComponent<BoxCollider2D>();
					boxColl1.offset = new Vector2(-0.279263079f,0.00575792789f);
					boxColl1.size = new Vector2(0.19362998f,1.35521626f);
                            		var boxColl2 = part2.AddComponent<BoxCollider2D>();
					boxColl2.offset = new Vector2(0.0918133259f,-0.533767998f);
					boxColl2.size = new Vector2(0.578393221f,0.273626357f);

					// [F R O N T   D O O R S] Collider
                        		var frontdoor = Instance.transform.GetChild(5);
					if(firstSpawn)
					{
						frontdoor.localPosition = new Vector3(1.449f,0.184f);
					}
                        		foreach(PolygonCollider2D Collider in Instance.transform.GetChild(5).gameObject.GetComponents<PolygonCollider2D>())
                            		{
                                		GameObject.Destroy(Collider);
                            		}
					var doorColl1 = Instance.transform.GetChild(5).gameObject.AddComponent<BoxCollider2D>();
					doorColl1.offset = new Vector2(0f,0f);
					doorColl1.size = new Vector2(1.08550811f,1.75694847f);

					// [B O N N E T] Collider
                        		var bonnet = Instance.transform.GetChild(3);
					if(firstSpawn)
					{
						bonnet.localPosition = new Vector3(3.11199999f,0.0289999992f);
					}
                        		foreach(PolygonCollider2D Collider in Instance.transform.GetChild(5).gameObject.GetComponents<PolygonCollider2D>())
                            		{
                                		GameObject.Destroy(Collider);
                            		}
					var bonnetColl1 = Instance.transform.GetChild(3).gameObject.AddComponent<BoxCollider2D>();
					bonnetColl1.offset = new Vector2(0f,0f);
					bonnetColl1.size = new Vector2(1.49043679f,0.308548152f);

                        		foreach(BoxCollider2D boxCollider in Instance.transform.GetChild(0).gameObject.GetComponents<BoxCollider2D>())
                            		{
                                		GameObject.Destroy(boxCollider);
                            		}
					// [B O D Y] Collider	
                        		body.GetComponent<PolygonCollider2D>().pathCount = 2;
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(4.00939512f,0.196775556f),
						new Vector2(3.85015607f,0.198074698f),
						new Vector2(3.85812759f,-0.131709263f),
						new Vector2(2.364223f,-0.131373107f),
						new Vector2(2.35977983f,0.196042567f),
						new Vector2(2.06715584f,0.204687938f),
						new Vector2(2.06926751f,1.0625211f),
						new Vector2(2.1394794f,1.06242454f),
						new Vector2(2.04813242f,1.17636657f),
						new Vector2(1.41548955f,1.25261915f),
						new Vector2(0.645284534f,1.2545805f),
						new Vector2(0.441096157f,1.21331334f),
						new Vector2(0.438340634f,0.537330449f),
						new Vector2(0.318039954f,0.541327953f),
						new Vector2(0.272420883f,0.534402847f),
						new Vector2(0.274506509f,-0.710823357f),
						new Vector2(-4.23820019f,-0.710960567f),
						new Vector2(-4.2359643f,0.548600018f),
						new Vector2(-4.38256264f,0.548354149f),
						new Vector2(-4.40136003f,-0.404153377f),
						new Vector2(-4.35742235f,-0.450973749f),
						new Vector2(-4.33878756f,-0.769166231f),
						new Vector2(-3.93512011f,-0.816076696f),
						new Vector2(-3.92669606f,-0.989206791f),
						new Vector2(0.303308249f,-0.991243422f),
						new Vector2(0.29929024f,-1.259987f),
						new Vector2(2.42529345f,-1.25745094f),
						new Vector2(3.87039566f,-1.05509555f),
						new Vector2(4.39331436f,-0.557967365f),
						new Vector2(4.25922298f,-0.353789151f),
						new Vector2(4.00771713f,-0.197585866f)
					});
                        		body.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[]
					{		
						new Vector2(0.686942577f,1.06611729f),
						new Vector2(1.98996735f,1.06446505f),
						new Vector2(1.98848748f,-0.692676783f),
						new Vector2(0.686047077f,-0.692777038f)
					});
                        	}
			}
		);
		/*
    		//ZIS-5
            	ModAPI.Register(
                	new Modification()
                	{
                    		OriginalItem = ModAPI.FindSpawnable("Rod"),
                    		NameOverride = "Plane" + Modtag,
                    		NameToOrderByOverride = "CACC Plane",
                    		DescriptionOverride = "<color=yellow>[By: Creator]<color=white>" + "\nPlane",
                    		CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    		ThumbnailOverride = ModAPI.LoadSprite("Vehicles/ZIS-5/Thumb.png", 0.1f), 
                    		AfterSpawn = (Instance) =>
                    		{
					Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Vehicles/Plane/Front.png");
					Instance.FixColliders();

                        		GameObject part2 = new GameObject("Tail");
                        		part2.transform.parent = Instance.transform;
                        		part2.transform.localScale = Vector3.one;
                        		part2.transform.localPosition = new Vector3(-4.38899994f,-0.00200000009f);
                        		SpriteRenderer part2Renderer = part2.AddComponent<SpriteRenderer>();
                        		part2Renderer.sprite = ModAPI.LoadSprite("Vehicles/Plane/Tail.png");
                        		part2Renderer.sortingLayerName = "Foreground";
                        		part2.layer = LayerMask.NameToLayer("Objects");
                        		part2.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint = part2.AddComponent<FixedJoint2D>();
                        		fixedJoint.connectedBody = Instance.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint.breakForce = 875f;
                        		part2.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		part2.AddComponent<AudioSourceTimeScaleBehaviour>();
                       	 		var jointBeh = part2.AddComponent<PlaneBreakBehaviour>();
					jointBeh.tailRen = part2Renderer;
					jointBeh.baseRen = Instance.GetComponent<SpriteRenderer>();
					jointBeh.brokenTailSprite = ModAPI.LoadSprite("Vehicles/Plane/Broken Tail.png");
					jointBeh.brokenBaseSprite = ModAPI.LoadSprite("Vehicles/Plane/Broken Front.png");
					jointBeh.particleName = "BigExplosion";
					jointBeh.UsingSprites = true;
					jointBeh.vector = new Vector3(0f,0f);
					part2.AddComponent<PolygonCollider2D>().SetPath(0, new Vector2[]
					{
						new Vector2(0.503660083f,0.176908985f),
						new Vector2(-0.736412883f,0.304398715f),
						new Vector2(-1.56962883f,1.13775003f),
						new Vector2(-1.76807094f,1.43135011f),
						new Vector2(-2.15658927f,1.85568035f),
						new Vector2(-2.9529047f,1.85076678f),
						new Vector2(-2.95247078f,1.54861236f),
						new Vector2(-2.4440403f,0.549097002f),
						new Vector2(-2.27818346f,-0.00592336059f),
						new Vector2(-2.22839856f,-0.379901618f),
						new Vector2(-2.08347225f,-0.511576891f),
						new Vector2(-1.78163671f,-0.626595736f),
						new Vector2(-0.606626213f,-0.760049582f),
						new Vector2(0.591096878f,-0.877560735f),
						new Vector2(1.69341779f,-0.966373682f),
						new Vector2(1.69371653f,0.0212804377f)
					});

                        		GameObject door = new GameObject("Door");
                        		door.transform.parent = Instance.transform;
                        		door.transform.localScale = Vector3.one;
                        		door.transform.localPosition = new Vector3(0.55f,-0.252f);
                        		SpriteRenderer doorRenderer = door.AddComponent<SpriteRenderer>();
                        		doorRenderer.sprite = ModAPI.LoadSprite("Vehicles/Plane/Door.png");
                        		doorRenderer.sortingLayerName = "Top";
                        		door.layer = LayerMask.NameToLayer("Objects");
                        		door.AddComponent<Rigidbody2D>().mass = 0.5f;
                        		FixedJoint2D fixedJoint1 = door.AddComponent<FixedJoint2D>();
                        		fixedJoint1.connectedBody = Instance.gameObject.GetComponent<Rigidbody2D>();
                        		fixedJoint1.breakForce = 750f;
                        		door.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
                        		door.AddComponent<AudioSourceTimeScaleBehaviour>();
					door.AddComponent<BoxCollider>();

                        		GameObject background = new GameObject("Background");
                        		background.transform.parent = Instance.transform;
                        		background.transform.localScale = Vector3.one;
                        		background.transform.localPosition = new Vector3(0f,0f);
                        		SpriteRenderer backgroundRenderer = background.AddComponent<SpriteRenderer>();
                        		backgroundRenderer.sprite = ModAPI.LoadSprite("Vehicles/Plane/Background.png");
                        		backgroundRenderer.sortingLayerName = "Bottom";
                        		background.layer = LayerMask.NameToLayer("Objects");
				}
			}
		);
		*/
        }
    }
	    class ChangeSpeedBehaviour : MonoBehaviour
    {
	public float orgSpeed;
	public float curSpeed;
        public DialogBox dialog = (DialogBox)null;

	void Start()
	{
	    curSpeed = orgSpeed;
	}

        private void Awake() => Buttons();
	void Buttons()
	{
	    GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("speed", "Change car speed", "Change car speed", () =>
	    {
		dialog = DialogBoxManager.TextEntry("Change car speed \n<color=yellow>Original speed: " + orgSpeed + "\n<color=green>Current speed: " + curSpeed, "Change car speed", new DialogButton("Apply", true, new UnityAction[1]
                {
                    (UnityAction)(() =>
                    {
                        curSpeed = float.Parse(dialog.EnteredText);
                        GetComponent<CarBehaviour>().MotorSpeed = curSpeed;
                        ModAPI.Notify("Changed car speed to " + curSpeed);
                    })
                }),
                new DialogButton("Close", true, (UnityAction)(() => dialog.Close())));
	    }));
	}
    }
    class PlaneBreakBehaviour : MonoBehaviour
    {
	public string particleName;
	public Vector3 currentPos;
        public Joint2D[] Joints;
	public Vector3 vector;
	public bool UsingSprites;
	public SpriteRenderer tailRen;
	public SpriteRenderer baseRen;
	public Sprite brokenTailSprite;
	public Sprite brokenBaseSprite;
	void Start()
	{
	    Joints = GetComponents<Joint2D>();
	}
	void Update()
	{
	    currentPos = GetComponent<Transform>().position;
	}
	public void OnJointBreak2D(Joint2D joint)
	{
	     ModAPI.CreateParticleEffect("" + particleName, currentPos + vector);  
	    if(UsingSprites)
	    {
	     tailRen.sprite = brokenTailSprite;
	     baseRen.sprite = brokenBaseSprite;
	    }
	}
    }
/*
    class CarRadioBehaviour : MonoBehaviour
    {
	private ContextMenuButton menuButton;
	public bool enabled = false;
	public AudioClip[] tracks;
	private int trackIndex;
	public AudioSource audiosrc;

	void Start()
	{
	    this.tracks = new AudioClip[]
	    {
		ModAPI.LoadSound("DeagleShot.wav")
	    };
	    this.audiosrc = GetComponent<Transform>().gameObject.AddComponent<AudioSource>();
	}
        private void Awake() => Button();
	public void Button()
	{
		GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(menuButton = new ContextMenuButton("1-Radio", "Radio - Next Track", "Radio - Next Track", new UnityAction[1]
		{
			(UnityAction) (() =>
			{
				NextSong();
                        	ModAPI.Notify("Now playing: [Insert]");
			})
		}));
	}
	public void NextSong()
	{
		if (!this.enabled)
		{
			return;
		}
		this.audiosrc.clip = this.SetTrackFromOffset(1);
		this.audiosrc.Play();
	}

	private AudioClip SetTrackFromOffset(int offset)
	{
		this.trackIndex += offset;
		if (this.trackIndex >= this.tracks.Length)
		{
			this.trackIndex = 0;
		}
		if (this.trackIndex < 0)
		{
			this.trackIndex = this.tracks.Length - 1;
		}
		return this.tracks[this.trackIndex];
	}
	public void PlayIndex(int index)
	{
		this.audiosrc.clip = this.SetTrackFromIndex(index);
		this.audiosrc.Play();
	}
	private AudioClip SetTrackFromIndex(int index)
	{
		this.trackIndex = index;
		if (this.trackIndex >= this.tracks.Length)
		{
			this.trackIndex = 0;
		}
		if (this.trackIndex < 0)
		{
			this.trackIndex = this.tracks.Length - 1;
		}
		return this.tracks[this.trackIndex];
	}
    }
*/
}